#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/syslog.h>
#include <errno.h>
#include "../shared/include/nvram.h"

#define DPRINTF(arg...)

int main(int argc, char **argv)
{
	int fd;
	char buf;
	int res;

	if (!strcmp(nvram_safe_get("WDG_OFF"), "1")) // watchdog is closed
	    exit (0);

	res=nice (-30);
	DPRINTF("the nice value is = %d\n", res);
	fd = open("/dev/wdt", O_WRONLY);
	if (fd < 0 ) 
	{
		syslog(LOG_INFO,"Can not open the watchdog");
		DPRINTF("Can not open the watchdog\n");
		exit(0);
	}
	while (1)
	{
		sleep(5);
		if (write(fd, &buf, 1) < 1)
		{
		    syslog(LOG_INFO,"Can not reset the watchdog: %d", errno);	
		    DPRINTF("Can not reset the watchdog: %d\n", errno);
		}
	}
	close (fd);
}
