#ifndef _SHARED_VALUE_H

#define _SHARED_VALUE_H

/* define the MAX number for each feature */
#define MAX_ALIAS_NUM		4
#define MAX_WDS_NUM		4	// start from 1
#define MAX_WLAN_FT_NUM		32
#define MAX_XDSL_PROF_NUM	1



/* config definition */

#define FUNC_ENABLED		"1"
#define FUNC_DISABLED		"0"

#define TIMER_DAY		0
#define TIMER_HOUR		1

/* ----- DEVICE service */
#define DEVICE_MODE_ROUTER	"router"

#define WAN_PORT_ADSL		"ADSL"
#define WAN_PORT_3G		"3G"
#define WAN_PORT_EWAN		"EWAN"
#define WAN_PORT_IBURST		"iBurst"
#define WAN_MAIN_PFNAME         "wan_main"

/* ADSL type */
#define ADSL_ANNEX_DSLAM	0
#define ADSL_ANNEX_A		1
#define ADSL_ANNEX_L		2
#define ADSL_ANNEX_M		3
#define ADSL_ANNEX_J		4
#define ADSL_ANNEX_B		5

/* operation mode */
#define ADSL_MOD_AUTO		0
#define ADSL_MOD_ADSL1MULTI	1
#define ADSL_MOD_ADSL2		2
#define ADSL_MOD_ADSL2P		3
#define ADSL_MOD_GLITE		4
#define ADSL_MOD_T1413		5
#define ADSL_MOD_GDMT		6

/* SNR */
#define ADSL_SNR_MORMAL		0
#define ADSL_SNR_IPTV		1
#define ADSL_SNR_MAXRATE	2

/* protocol type */
#define XDSL_PROT_PPPOE		"pppoe"
#define XDSL_PROT_PPPOA		"pppoa"
#define XDSL_PROT_1483		"1483"		//mpoa
#define XDSL_PROT_PURE_BRIDGE	"bridge"

#define XDSL_MODE_BRIDGE	"BR"
#define XDSL_MODE_ROUTE		"RT"


#define XDSL_ENCAP_LLC		"0"
#define XDSL_ENCAP_MUX		"2"

/* PPP protocol */
#define PPP_AUTH_AUTO           "0"
#define PPP_AUTH_PAP            "1"
#define PPP_AUTH_CHAP           "2"


/* -----  DHCPD service   */
#define DHCPD_FUNC_SERVER	"server"
#define DHCPD_FUNC_RELAY	"relay"
#define DHCPD_FUNC_DISABLE	""

/* ----- WLAN part */
#define WLAN_INTERFACE		"ra0"  // ralink

/* WLAN mode */
#define WLAN_MODE_BG		0
#define WLAN_MODE_B		1
#define WLAN_MODE_G		2
#define WLAN_MODE_A		3

/* define WLAN SECURITY */
#define WLAN_SEC_DISABLE	""
#define WLAN_SEC_WEP		"WEP"
#define WLAN_SEC_WPA		"WPA"
#define WLAN_SEC_WPA2		"WPA2"

#define WLAN_WPA_ALG_TKIP	"TKIP"
#define WLAN_WPA_ALG_AES	"AES"

#define WLAN_WEP_OPEN		"OPEN"
#define WLAN_WEP_SHARED		"SHARED"
#define WLAN_WEP_AUTO		"WEPAUTO"

#define WPS_MODE_INIT         0
#define WPS_MODE_RPIN         1		// registrar's PIN
#define WPS_MODE_RPBC         2		// registrar's PBC
#define WPS_MODE_EPIN	      3		// enrolee's PIN
#define WPS_MODE_EPBC	      4		// enrolee's PBC
#define WPS_MODE_CHECK	      5

/* RIP */
#define RIP_NO			0
#define RIP_V1			1
#define RIP_V2			2
#define RIP_V2MUTI		3
#define RIP_V1V2		4

/* NTP */

/* HTTPD */
#define HTTPD_PORT              80
#define HTTPD_LOGOUT_TM 180

/* Static Route */
#define ST_RT_MAX               16

/* Time Schedule */
#define TS_MAX                  16
#define TS_DEF_S_H              8
#define TS_DEF_S_M              0
#define TS_DEF_E_H              18
#define TS_DEF_E_M              0

/* LED Control */
#define LED_ON			"1"
#define LED_OFF			"0"
#define LED_FLASH		"2"

/* LINK CONNECTION STATUS */
#define WANLINK_DOWN		"0"  
#define WANLINK_DROPPING	"1"	
#define WANLINK_BUILDING	"2"
#define WANLINK_UP		"3"
#define WANLINK_WAIT		"4"
#define WANLINK_NO_RESP         "-1"
#define WANLINK_AUTH_ERR        "-2"


/* FIREWALL */
#define PF_PREFIX					"PF"
#define VS_PREFIX					"VS"
#define DMZ_PREFIX					"DMZ"
#define DOMAIN_ALLOW_CHAIN_PREFIX	"DM_A"
#define DOMAIN_BLOCK_CHAIN_PREFIX	"DM_B"
#define KEYWORD_CHAIN_PREFIX		"KW"
#define EXCEPTED_IP_PREFIX			"UF_EIP"
#define MF_PREFIX					"MF"


/* Default MAX of rules */
#define PF_DEFAULT_MAX                  64
#define VS_DEFAULT_MAX                  32
#define DMZ_DEFAULT_MAX                 1
#define UF_DEFAULT_MAX                  32
#define UF_DEFAULT_IP_MAX               16
#define MF_DEFAULT_MAX                  16

#define FW_MAX_INDEX            999

/* Firewall - URL Filter */
#define BLK_JAVA                0x01
#define BLK_ACTIVEX             0x02
#define BLK_COOKIE              0x04
#define BLK_PROXY               0x08

#define MAX_URL_LENGTH                  128

/* QoS */
#define QOS_PREFIX                     "QOS"
#define QOS_MAX_RULES                   16
#define QOS_DSCP_MARK_DISABLE        0xFF
#define QOS_DSCP_MARK_BESTEFFORT  0x0
#define QOS_DSCP_MARK_PREMIUM       0x2E
#define QOS_DSCP_MARK_GOLD_LOW     0x0A
#define QOS_DSCP_MARK_GOLD_MED     0x0C
#define QOS_DSCP_MARK_GOLD_HIGH    0x0E
#define QOS_DSCP_MARK_SILVER_LOW  0x12
#define QOS_DSCP_MARK_SILVER_MED   0x14
#define QOS_DSCP_MARK_SILVER_HIGH  0x16
#define QOS_DSCP_MARK_BRONZE_LOW    0x1A  /* 0001 1010 */
#define QOS_DSCP_MARK_BRONZE_MED    0x1C  /* 0001 1100 */
#define QOS_DSCP_MARK_BRONZE_HIGH   0x1E  /* 0001 1110 */

/* define LAN/WAN type */
#define DEVICE_LAN_TYPE		0
#define DEVICE_WAN_TYPE		1

#define ID_MAN_MASK		0x00
#define ID_LAN_MASK		0x10

/*define 3G status */
#define T3G_NOT_ACT		"0"
#define T3G_OK			"1"
#define T3G_SIM_ERR		"-1"
#define T3G_SIM_LOST		"-2"
#define T3G_NO_CARD		"-3"
#define T3G_UNKNOW_CARD		"-4"
#define T3G_REG_FAIL		"-5"
#define T3G_SIM_LOCK		"-6"
#define T3G_NO_RSP		"-7"

#define T3G_MODE_GPRS		"0"
#define T3G_MODE_UMTS		"2"

// failover
#define PING_NONE               0
#define PING_GW                 1
#define PING_IP                 2

#endif 
