/*
 * Generic interrupt handler for Trendchip boards
 */

#include <linux/config.h>

#include <asm/asm.h>
#include <asm/mipsregs.h>
#include <asm/regdef.h>
#include <asm/stackframe.h>

#define CR_INTC_BASE    0xBFB40000                
#define CR_INTC_IVR     (CR_INTC_BASE+0x0030)     

	.text
#ifdef CONFIG_CPU_IMEM
	.section .text.imem
#endif
	.set	noreorder
	.align	5
	NESTED(tc3162_handle_int, PT_SIZE, ra)
	.set	noat
	SAVE_ALL
	CLI
	.set	noreorder
	.set	at

	la		t0, CR_INTC_IVR
	lw		a0, 0(t0)
	nop
	jal		do_IRQ
	move	a1, sp

	j		ret_from_irq
	nop
		
	END(tc3162_handle_int)

