#ifndef _vram_h_
#define _vram_h_

typedef unsigned long uint32;
typedef unsigned short uint16;
typedef unsigned char uint8;

struct nvram_header {
	uint32 magic;
	uint32 len;
};

struct nvram_tuple {
	char *name;
	char *value;
	struct nvram_tuple *next;
};

#define ARRAYSIZE(a)	(sizeof(a)/sizeof(a[0]))
#define ROUNDUP(x, y)   ((((x)+((y)-1))/(y))*(y))

#define INLINE 		inline
#define CRC8_INIT_VALUE  0xff

#define SWAP32(x) \
    ((unsigned long)( \
    (((unsigned long)(x) & (unsigned long) 0x000000ffUL) << 24) | \
    (((unsigned long)(x) & (unsigned long) 0x0000ff00UL) <<  8) | \
    (((unsigned long)(x) & (unsigned long) 0x00ff0000UL) >>  8) | \
    (((unsigned long)(x) & (unsigned long) 0xff000000UL) >> 24) ))

#ifndef CONFIG_CPU_LITTLE_ENDIAN 
#define htol32(i) SWAP32(i)
#else
#define htol32(i) (i)
#endif

#define NVRAM_MAGIC		0x48534C46	/* 'FLSH' */
#define NVRAM_VERSION		1
#define NVRAM_HEADER_SIZE	20
#define NVRAM_SPACE		0x40000  // 128K

#define NVRAM_HASH_SIZE		1024

// ioctl
#define NVRAM_FREE              0x10
#define NVRAM_2FILE             0x20
#endif /* _bcmnvram_h_ */
