/*
** $Id: mgmt_timer.c 1.1 2003/12/11 14:31:49 cmchang Exp $
*/

/*! \file mgmt_timer.c
    \brief
*/

/******************************************************************************
Copyright (c) 2002-2003 Inprocomm, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with Inprocomm, Inc.
******************************************************************************/

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/


/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
LIST_HEAD(ipn2220_timer_root);

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
void mgmt_add_timer(mgmt_timer_t *timer)
{
	if (mgmt_timer_pending(timer))
		return;
	/*
	 * Timers are FIFO!
	 */
	list_add_tail(&timer->list, &ipn2220_timer_root);
	return;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
__KAL_INLINE__ int mgmt_detach_timer (mgmt_timer_t *timer)
{
	if (!mgmt_timer_pending(timer))
		return 0;
	list_del(&timer->list);
	return 1;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int mgmt_del_timer(mgmt_timer_t *timer)
{
	int ret;

	ret = mgmt_detach_timer(timer);
	timer->list.next = timer->list.prev = NULL;
	return;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
void mgmt_start_timer(mgmt_timer_t *tmr, unsigned long interval,
                        mgmt_timeout_func func, unsigned long data)
{
        tmr->expires = kal_jiffies + interval;
        tmr->data = data;
        tmr->function = func;
        mgmt_add_timer(tmr);
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
void do_timer_check(void)
{
        mgmt_timer_t            *timer;
        struct list_head        *lst, *next_lst;

	for (lst = ipn2220_timer_root.next; lst != &ipn2220_timer_root;
	     lst = next_lst) {
                next_lst = lst->next;
                timer = list_entry(lst, mgmt_timer_t, list);
                if ( check_timeout(timer->expires)) {                        
                        mgmt_del_timer(timer);
                        (timer->function)(timer->data);
                }
        }
}

