/*
** $Id: params.c 1.64 2004/10/04 17:17:13 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Inprocomm, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with Inprocomm, Inc.
******************************************************************************/

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"

// Sam add for WLAN_LED
#define	TC3162P_LIGHT_WLAN_LED 1
#if TC3162P_LIGHT_WLAN_LED
#include "asm/tc3162/gpio.h"
#endif
// End Sam add

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define BASICRATE_CCK_ALL \
        (BasicRate_1M | BasicRate_2M | BasicRate_5_5M | BasicRate_11M)
#define BASICRATE_G_ONLY \
        (BASICRATE_CCK_ALL | BasicRate_6M | BasicRate_12M | BasicRate_24M)

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/


/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/
#ifdef IPN_NEW_KAL
int sprintf(char * buf, const char * fmt, ...);
#endif
/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/
/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_ssid_id(void *dev, int whichSsid)
{
#if SUPPORT_MSSID
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (whichSsid > MAX_SSID -1 || whichSsid < 0) {
                return -1;
        }
        priv_p->param_ssid_index = whichSsid;
        return 0;
#else
        return -1;
#endif
}


/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_ssid(void *dev, param_ssid_t *data)
{
#if SUPPORT_MSSID
        param_set_ssid_id(dev, 0);
        return param_set_m_ssid(dev, data);
#else
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data->len > MAX_SSID_LEN) {
                return -1;
        }

        mib_import(dot11DesiredSSID.ssidLen) = data->len;
        ipn_memcpy(mib_import(dot11DesiredSSID.ssid), data->ssid, data->len);

        MlmeStart_request(priv_p);
        return 0;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param 0 ~ MAX_SSID -1. You can use zero lenth ssid to clear record. 0 is for primary
* \return
*/
/*----------------------------------------------------------------*/
int param_set_m_ssid(void *dev, param_ssid_t *data)
{
#if SUPPORT_MSSID
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int             ssid_id = priv_p->param_ssid_index;

        if (data->len > MAX_SSID_LEN || data->len < 0) {
                return -1;
        }

        if (ssid_id > MAX_SSID -1 || ssid_id < 0) {
                return -1;
        }

        priv_p->ap.ssid_list[ssid_id].ssid_len = data->len;
        ipn_memcpy(priv_p->ap.ssid_list[ssid_id].ssid,
                data->ssid, data->len);
        MlmeStart_request(priv_p);
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param 0 ~ 4095
* \return
*/
/*----------------------------------------------------------------*/
int param_set_m_vlanid(void *dev, int vlanid)
{
#if SUPPORT_MSSID
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int             ssid_id = priv_p->param_ssid_index;

        if (vlanid > 4095 || vlanid < 0) {
                return -1;
        }

        if (ssid_id > MAX_SSID -1 || ssid_id < 0) {
                return -1;
        }

        priv_p->ap.ssid_list[ssid_id].vlanid = vlanid;
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param 0 ~ 4095
* \return
*/
/*----------------------------------------------------------------*/
int param_set_m_vlantag_enable(void *dev, int enable)
{
#if SUPPORT_MSSID
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int             ssid_id = priv_p->param_ssid_index;

        if (ssid_id > MAX_SSID -1 || ssid_id < 0) {
                return -1;
        }
        priv_p->ap.ssid_list[ssid_id].vlan_tag_enabled = enable ? TRUE : FALSE;

        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_m_enable(void *dev, int enable)
{
#if SUPPORT_MSSID
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int                      ssid_id = priv_p->param_ssid_index;

        /* 0 is reserved for primary SSID only. And primary SSID is always enabled.
        */
        if (ssid_id > MAX_SSID -1 || ssid_id < 1) {
                return -1;
        }
        priv_p->ap.ssid_list[ssid_id].enabled = enable ? true : false;

        MlmeStart_request(priv_p);
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_bcnPeriod(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 20 || data > 1000)
                return -1;

        mib_import(dot11BeaconPeriod) = data;

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_dtimPeriod(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 1 || data > 10)
                return -1;

        mib_import(dot11DTIMPeriod) = data;

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_setRFBand(void *dev, int data)
{
#if SUPPORT_802_11A
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if ((data == CHANNEL_BAND_24 && priv_p->numOperatingChannels24) ||
            (data == CHANNEL_BAND_5 && priv_p->numOperatingChannels5)) {

                priv_p->channelBand = data;
                return 0;
        }
#endif
        return -1;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_setChannel(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

#if SUPPORT_802_11A
        if (data &&
           !domainCheckForValidChannel(priv_p,(UINT8)data,priv_p->channelBand)){
                return -1;
        }
#else
        if (data &&
            !domainCheckForValidChannel(priv_p, (UINT8)data)) {
                return -1;
        }
#endif

        mib_import(dot11CurrentChannel) = data;

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_rts(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 2347)
                return -1;

        mib_import(dot11RTSThreshold) = data;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_frag(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 256 || data > 2346)
                return -1;

        mib_import(dot11FragmentationThreshold) = data;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_basicRateSet(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int             i, j, num;
        UINT8           rateValue = 0;

        num = mib_import(dot11OperationalRateSet.rateSetSize);

        for(i = 0; i < num; i++)
                sdl_notBasicRate(mib_import(dot11OperationalRateSet).rateSet[i]);
        for(i = 0; i < num; i++) {
                switch ( data & BIT(i) ) {
                case BasicRate_1M:
                        rateValue = RATE_1M;
                        break;
                case BasicRate_2M:
                        rateValue = RATE_2M;
                        break;
                case BasicRate_5_5M:
                        rateValue = RATE_5_5M;
                        break;
                case BasicRate_11M:
                        rateValue = RATE_11M;
                        break;
                case BasicRate_6M:
                        rateValue = RATE_6M;
                        break;
                case BasicRate_9M:
                        rateValue = RATE_9M;
                        break;
                case BasicRate_12M:
                        rateValue = RATE_12M;
                        break;
                case BasicRate_18M:
                        rateValue = RATE_18M;
                        break;
                case BasicRate_24M:
                        rateValue = RATE_24M;
                        break;
                case BasicRate_36M:
                        rateValue = RATE_36M;
                        break;
                case BasicRate_48M:
                        rateValue = RATE_48M;
                        break;
                case BasicRate_54M:
                        rateValue = RATE_54M;
                        break;
                } /* end of switch */

                for (j = 0; j < num; j++) {
                        if (sdl_rateVal(mib_import(dot11OperationalRateSet).rateSet[j]) == rateValue) {
                                sdl_basicRate(mib_import(dot11OperationalRateSet).rateSet[j]);
                                break;
                        }
                }
        }

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_rateMode(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int             basicRates;

        /* 0: mixed mode, 1: g-only, 2: b-only */
        if (data < 0 || data > 2)
                return -1;

        mib_import(dot11OperationalRateSet.rateSetSize) = (data == 2) ? 4 : 12;
        basicRates = (data == 1) ? BASICRATE_G_ONLY : BASICRATE_CCK_ALL;

        return param_set_basicRateSet(dev, basicRates);
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_bcastSSID(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        priv_p->x_hide_ssid = data ? FALSE : TRUE;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_ctsProtect(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 2)
                return -1;

        priv_p->protectMode = data;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_preambleMode(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 2)
                return -1;

        priv_p->preambleMode = data;

        priv_p->phyPreambleType = (priv_p->preambleMode == PREAMBLE_MODE_LONG) ?
                        phyLongPreamble : phyShortPreamble;

        /* In MlmeStart_request, hw_set_rate_table() will be invoked */
        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_dataRate(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        UINT32          dataRate;

        dataRate = data * 2 / 1000000;
        priv_p->fixedTxRate_p = __get_txRate_info(priv_p, (UINT8)dataRate);
        return (data && !priv_p->fixedTxRate_p) ? -1 : 0;

}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_burstMode(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        priv_p->x_CfbBurst = data;
        pauChangeSlotTime(priv_p,
                (priv_p->phySlotType == phyLongSlot) ?
                SLOT_TIME_ERP_LONG : SLOT_TIME_ERP_SHORT,
                priv_p->x_CfbBurst ? FALSE : TRUE);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_noRelay(void *dev, param_relayMode_t mode)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if((mode >  RelayMode_DATA_PIPE) || (mode < RelayMode_SWITCH))
                return -1;

        priv_p->relay_mode = mode;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_killmac(void *dev, unsigned char *data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        sta_info_t      *sta_p;

        if ((sta_p = task_sta_lookup(priv_p, (MacAddr_t)data)) != NULL) {
                free_sta(priv_p, sta_p);
        } else if (sdl_isBcst(data)) {
                cmd_deauth_sta(priv_p->netdev, bcstAddr);
        }
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_rxAntenna(void *dev, int rxAntenna)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (rxAntenna < 0 || rxAntenna > 2)
                return -1;

        /* 0: diversity, 1: primary, 2: secondary */
        if (rxAntenna == 0) {
                rxAntenna = (int) MIB_ANTENNA_DIVERSITY;
        }
        mib_import(dot11CurrentRxAntenna) = (ULONG)rxAntenna;

        /* Set the Rx antenna mode according to the new MIB attributes. */
        antSetRxAntennaMode(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_authmode(void *dev, param_authMode_t data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        /* We only allow legacy mode. Other modes are ignored. */
        if (data < AuthMode_OPEN || data > AuthMode_SWITCH)
                return -1;

        /* Update authentication mode. */
        wlanoidSetAuthenticationMode(priv_p, data);
        /* In MlmeStart_request(), all station records are cleaned up
         * except WDS. Four group keys ???
         */
        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_cipherMode(void *dev, param_cipherMode_t data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        /* We only allow WEP cipher mode. Other modes can be enabled/disabled
         * by setting group key funtion cmd_set_macKey().
         */
        if (data != CipherMode_NONE && data != CipherMode_WEP40 &&
            data != CipherMode_WEP104 && data != CipherMode_WEP128) {
                return -1;
        }

        /* Update unicast and grooup cipher mode. In IPNRSN, unicast
         * and group cipher modes are the same.
         */
        wlanoidSetEncryptionStatus(priv_p, data);

        /* In MlmeStart_request(), all station records are cleaned up
         * except WDS. Four group keys ???
         */
        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wepDefaultKeyId(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 3)
                return -1;

        /* DefaultKeyID = 0, 1, 2, 3 */
        priv_p->DefaultKeyID = data;

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wepKeyId(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 3)
                return -1;

        priv_p->param_keyid_index = data;
        return 0;
}
/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_hwMICthreshold(void *dev, unsigned short level)
{
#if SUPPORT_SW_TKIP_MIC
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        priv_p->HWMICthreshold = level;
        return 0;
#else
        return -1;
#endif
}


/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wepKey(void *dev, param_cipher_key_t *data)
{
        i2220mgmt_t                     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        DOT11_WEP_DEFAULT_KEYS_ENTRY    *defKey_p;
        IPN_KEY_STRUC                   k;

        if (data->len == 5)
                k.cipher = CipherMode_WEP40;
        else if (data->len == 13)
                k.cipher = CipherMode_WEP104;
        else if (data->len == 16)
                k.cipher = CipherMode_WEP128;
        else    return -1;

        k.chkKeyId = TRUE;
        k.chkAddr2 = FALSE;
        k.chkAddr1 = FALSE;
        k.keyId = priv_p->param_keyid_index;
        ipn_memcpy(k.addr, bcstAddr, 6);
        ipn_memcpy(k.keyMaterial, data->key, min(16,data->len));

        /* Set H/W key table */
        if (wlanoidSetAddKey(priv_p, &k) != 0) {
                return -1; /* Fail */
        }

        /* Store key to default cipher setting, too */
        defKey_p = &mib_import(dot11WEPDefaultKeysTable[priv_p->param_keyid_index]);
        ipn_memcpy(defKey_p->dot11WEPDefaultKeyValue, data->key, data->len);
        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief For WLAN0
*  Stop: 1. stop sending beacon.
*        2. stop responding to probe_req
*        3. stop responding to authenticating
*        4. stop responding to associating
*        5. stop processing data frame from stations.
*
*  Start:1. start sending beacon.
*        2. start responding to probe_req
*        3. start responding to authenticating
*        4. start responding to associating
*        5. start processing data frame from stations.
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_noStation(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

#if WLAN_INCLUDE_WDS
        if(!is_main_device(dev))
                return -1;
#endif
        /* data: TRUE --> disable AP function */
        priv_p->stop_accept_station = data ? TRUE : FALSE;

#if TC3162P_LIGHT_WLAN_LED
	if (data == 1) //set_noStation = 1, light off WLAN LED
	{
	    unsigned short gpiodata;

            cmd_deauth_sta(priv_p->netdev, bcstAddr);
	    // Step 0. turn off WLAN LED	
            gpiodata = *(volatile unsigned short*)TC3162_GPDATA_REG;
            gpiodata |= (1<<(GPIO_WIRELESS_LED/2));
            *(volatile unsigned short*)TC3162_GPDATA_REG = gpiodata;
            // Step 1. Disable GPIO_11 open drain
            gpiodata = *(volatile unsigned short*)(TC3162_GPOPENDRAIN_REG);
            gpiodata &=(~(1 <<(GPIO_WIRELESS_LED/2)));
            *(volatile unsigned short *)TC3162_GPOPENDRAIN_REG = gpiodata;

        }
	else //set_noStation = 0, light on WLAN LED
	{
            unsigned short gpiodata;
            // Step 1. enable GPIO_11 open drain
            gpiodata = *(volatile unsigned short*)(TC3162_GPOPENDRAIN_REG);
            gpiodata |= (1 <<(GPIO_WIRELESS_LED/2));
            *(volatile unsigned short *)TC3162_GPOPENDRAIN_REG = gpiodata;	
	    // Step 2. light on WLAN_LED
            gpiodata = *(volatile unsigned short*)TC3162_GPDATA_REG;
            gpiodata &= ~(1<<(GPIO_WIRELESS_LED/2));
            *(volatile unsigned short*)TC3162_GPDATA_REG = gpiodata;
	}
#endif

        return 0;
}
/*----------------------------------------------------------------*/
/*!
* \brief Set WDS TX failure allowance
*
* \param data is packets allowed
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wds_tx_failure_limit(void *dev, int data)
{
#if WLAN_INCLUDE_WDS
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if(data > 1)
                priv_p->wds_tx_failure_limit = data;
        else
                return -1;

        return 0;
#else
        return -1;
#endif
}
/*----------------------------------------------------------------*/
/*!
* \brief Set WDS Dsiable limit because of TX failure, in system ticks
*
* \param data is in seconds
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wds_disable_limit(void *dev, int data)
{
#if WLAN_INCLUDE_WDS
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if(data > 1)
                priv_p->wds_disable_limit = data * HZ;
        else
                return -1;

        return 0;
#else
        return -1;
#endif
}
/*----------------------------------------------------------------*/
/*!
* \brief For WLAN0WDS0
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wds_rateMode(void *dev, int data)
{
#if WLAN_INCLUDE_WDS
        UINT8                 txRate;
        UINT32               phyMode;
        sta_info_t*          remote_ap_p;
        unsigned long      sup_rate;
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        wdslink_info_t*    wds_link;

        if(is_main_device(dev))
                return -1;

        if (data < 0 || data > 1)
                return -1;

        if(data == 1){
                sup_rate = RATE_SET_MASK_DSSS_CCK|RATE_SET_MASK_OFDM;
        }else if(data == 0){
                sup_rate = RATE_SET_MASK_DSSS_CCK;
        }else
                return -1;

        wds_link = wds_by_dev(dev);
        if(!wds_link)
                return -1;

        remote_ap_p = wds_link->remote_ap;
        if(!remote_ap_p)
                return -1;

        remote_ap_p->asoc.adSuptRates = sup_rate;
        rateGetHighestRate(remote_ap_p->asoc.adSuptRates, RATE_54M,
                &txRate, &phyMode);
        remote_ap_p->curTxRate_p = __get_txRate_info(priv_p, txRate);
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wds_cipherKey(void *dev, param_cipher_key_t *data)
{
#if WLAN_INCLUDE_WDS
        wdslink_info_t  *wds;
        sta_info_t      *sta_p;

        if (!(wds = wds_by_dev(dev)) || !wds->remote_ap)
                return -1;

        sta_p = wds->remote_ap;
        ipn_memcpy(sta_p->encryptKey, data->key, data->len);

        return param_set_wds_cipherMode(dev, sta_p->cipherSuite);
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_wds_cipherMode(void *dev, param_cipherMode_t data)
{
#if WLAN_INCLUDE_WDS
        wdslink_info_t          *wds;
        sta_info_t              *sta_p;
        cmd_key_t               key;

        switch (data) {
        case CipherMode_NONE:   /* Disable */
                key.keyLen = 0;
                break;
        case CipherMode_WEP40:
                key.keyLen = 5;
                break;
        case CipherMode_WEP104:
                key.keyLen = 13;
                break;
        case CipherMode_WEP128:
        case CipherMode_CCMP:
                key.keyLen = 16;
                break;
        case CipherMode_TKIP:
                key.keyLen = 32;
                break;
        default:
                return -1;
        }

        if (is_main_device(dev) || (wds = wds_by_dev(dev)) == NULL ||
            wds->remote_ap == NULL) {
                return -1;
        }
        sta_p = wds->remote_ap;
        sta_p->cipherSuite = data;

        key.cipherMode = (unsigned char) data;
        key.keyId = 0;  /* Force keyId=0 here */

        /* If cipherSuite is TKIP, we make TxMIC and RxMIC keys be the
         * same manually. In this case, user only needs 128bits key length.
         */
        if (data == CipherMode_TKIP) {
                ipn_memcpy(sta_p->encryptKey+16, sta_p->encryptKey, 8);
                ipn_memcpy(sta_p->encryptKey+24, sta_p->encryptKey, 8);
        }
        ipn_memcpy(key.key, sta_p->encryptKey, key.keyLen);

        return cmd_set_macKey(dev, sta_p->asoc.adAddr, &key);
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_regDomain(void *dev, int data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        switch (data) {
        case MIB_REG_DOMAIN_JAPAN_2:
                data = MIB_REG_DOMAIN_JAPAN_1;
        case MIB_REG_DOMAIN_JAPAN_1:
        case MIB_REG_DOMAIN_FCC:
        case MIB_REG_DOMAIN_IC:
        case MIB_REG_DOMAIN_ETSI:
        case MIB_REG_DOMAIN_SPAIN:
        case MIB_REG_DOMAIN_FRANCE:
        #if SUPPORT_802_11D
                mib_import(dot11MultiDomainCapabilityEnabled) = FALSE;
        #endif
                priv_p->regCountryString[0] = 0;
                domainInitCurrentRegDomain(priv_p, (UINT16)data);
                break;
        default:
                return -1;
        } /* end of switch */

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_country(void *dev, char *data)
{
        i2220mgmt_t       *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        DOMAIN_INFO_ENTRY *domainInfo_p;

        /* Check if countryCode is known. "00" indicates "Disable" */
        domainCheckForSupportedDomain(((UINT16)data[0] << 8) |
                (UINT16)data[1], &domainInfo_p);
        if (domainInfo_p == NULL) {
                if (data[0] != '0' || data[1] != '0')
                        return -1;
        #if SUPPORT_802_11D
                mib_import(dot11MultiDomainCapabilityEnabled) = FALSE;
        #endif
        }
        else {
        #if SUPPORT_802_11D
                mib_import(dot11MultiDomainCapabilityEnabled) = TRUE;
        #endif
                priv_p->regCountryString[0] = data[0];
                priv_p->regCountryString[1] = data[1];
                domainInitCurrentRegDomain(priv_p, 0);
        }

        MlmeStart_request(priv_p);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_rftestMode(void *dev, int data)
{
#if WLAN_SUPPORT_RFTEST
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 3)
                return -1;

        i2220_rftest_mode(priv_p, (UINT8)data);
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_rftestPower(void *dev, int data)
{
#if WLAN_SUPPORT_RFTEST
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (data < 0 || data > 255)
                return -1;

        i2220_rftest_power(priv_p, data);
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
extern char *param_get_version(void *dev)
{
        return ipn2220_drv_ver; /* A global variable */
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_get_curChannel(void *dev, int *data)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        *data = priv_p->curChannel;
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_get_Statistic(void *dev, struct net_stat* out_stat)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if(!out_stat)
                return -1;

        out_stat->txunicastframes      = mib_import(dot11TransmittedFrameCount) - mib_import(dot11MulticastTransmittedFrameCount);
        out_stat->txmulticastframes   = mib_import(dot11MulticastTransmittedFrameCount);
        out_stat->txfragments           = mib_import(dot11TransmittedFragmentCount);
        out_stat->txsingleretryframes= mib_import(dot11RetryCount);
        out_stat->txmultipleretryframes= mib_import(dot11MultipleRetryCount);
        out_stat->txretrylimitexceeded= mib_import(dot11ACKFailureCount);
        out_stat->txbytes = priv_p->ap_statistics.tx_bytes;
        out_stat->rxbytes = priv_p->ap_statistics.rx_bytes;
        //This shoud be buffer not enough??
        out_stat->txdiscards               = mib_import(dot11FailedCount);
        out_stat->rxmulticastframes   = mib_import(dot11MulticastReceivedFrameCount);
        out_stat->rxfragments           = mib_import(dot11ReceivedFragmentCount);
        out_stat->rxfcserrors             = mib_import(dot11FCSErrorCount);
        out_stat->rxdiscardswepundecr= mib_import(dot11WEPUndecryptableCount);

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param num_station_buffer number of element available in  out_stations.
              out_stations[]         return station_list
* \return
*/
/*----------------------------------------------------------------*/
int param_get_StaList(void *dev, int size_of_buffer,
        sta_status_t* staS)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        sta_info_t          *sta_p;
        int                     i;
        int                     num_station_buffer = size_of_buffer/sizeof(sta_status_t);
	// Sam add
	int	k = 0;
	// End Sam add
        if(size_of_buffer < sizeof(sta_status_t))
                return -1;
#if 0
        for(i=0;(i<x_MAX_AID) && (i<num_station_buffer);i++){
                sta_p = priv_p->ap.sta_aid[i];
                if (sta_p && (sta_p->aid > 0)) {
                        staS[i].aid = sta_p->aid;
                        ipn_memcpy(staS[i].adAddr,sta_p->asoc.adAddr,MAC_ADDR_LEN);
                        staS[i].assoc_time = sta_p ->asoc.adAsocTickTime;
                        staS[i].auth_state  = Legacy_Associated;
                        staS[i].ps_state     = (sta_p->asoc.adPsm == SYN_power_save);
                }
        }
#endif
        for(i=0;(i<x_MAX_AID) && (i<num_station_buffer);i++){
                sta_p = priv_p->ap.sta_aid[i];
                if (sta_p && (sta_p->aid > 0)) {
                        staS[k].aid = sta_p->aid;
                        ipn_memcpy(staS[k].adAddr,sta_p->asoc.adAddr,MAC_ADDR_LEN);
                        staS[k].assoc_time = sta_p ->asoc.adAsocTickTime;
                        staS[k].auth_state  = Legacy_Associated;
                        staS[k].ps_state     = (sta_p->asoc.adPsm == SYN_power_save);
			k++;
                }
        }
 
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_get_curTimeStamp(void *dev, unsigned long *timeStamp)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        NIC_MCR_READ(priv_p,MCR_LTTR0,timeStamp);
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
* \return
*/
/*----------------------------------------------------------------*/
int param_set_loopBack(void *dev, unsigned int enable)
{
#if SUPPORT_LOOPBACK
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if(enable > 0){
                if(!priv_p->loop.enable){
                        NIC_MCR_WRITE(priv_p, MCR_PRBDR, 0x0400);
                        i2220hw_reset_mac(priv_p);
                }
                priv_p->loop.enable = true;
                priv_p->loop.times =   enable;
                priv_p->loop.value   = 0x01;
                priv_p->loop.length  = 1024;
                sdlu_send_looppacket(priv_p, priv_p->loop.length, priv_p->loop.value);
        }else{
                NIC_MCR_WRITE(priv_p, MCR_PRBDR, 0x0000);
                priv_p->loop.times   = 0;
                priv_p->loop.enable = false;
        }
        return 0;
#else
        return -1;
#endif
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_do_acl(void *dev, unsigned char *macAddr, int accept)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        sta_info_t      *sta_p;

        sta_p = task_sta_lookup(priv_p, macAddr);
        if (sta_p == NULL) return -1;

        if (accept) {
                sta_p->flags &= ~STA_INFO_ACL; /* accept */
        }
        else {
                sta_p->flags |= STA_INFO_ACL; /* reject */
                sdlf_send_deauth(priv_p, macAddr, SYN_auth_not_valid);
                if(sta_p->aid > 0) {
                        leave_assoc_state(priv_p, sta_p);
                }
        }
        return 0; /* success */
}


/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_deauth_sta_with_reason(void *dev,
                                unsigned char *macAddr, int reason)
{
        i2220mgmt_t             *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        struct list_head        *lst, *next_lst;
        sta_info_t              *sta_p;

        sdlf_send_deauth(priv_p, macAddr, reason);

        /* Here we don't free_sta() because this function can be called
         * in upper layer callback function. If driver free record and use
         * this reocrd after callback function, crash!!
         */
        if (sdl_isBcst(macAddr) ) {
                for (lst = priv_p->ap.sta_chain.head.next;
	             lst != &priv_p->ap.sta_chain.head; lst = next_lst) {
                        next_lst = lst->next;
                        sta_p = list_entry(lst, sta_info_t, sw.link);
                        sta_p->flags &= ~(STA_INFO_AUTH_OS |STA_INFO_AUTH_KEY);
                        if (sta_p->aid > 0) {
                                sdlf_send_deauth(priv_p, sta_p->asoc.adAddr,reason);
                                ClearPTK(priv_p, sta_p->asoc.adAddr, sta_p->keyId);
                                leave_assoc_state(priv_p, sta_p);
                        }
                }
        }
        else if ((sta_p = task_sta_lookup(priv_p, macAddr)) != NULL) {
                sta_p->flags &= ~(STA_INFO_AUTH_OS |STA_INFO_AUTH_KEY);
                if (sta_p->aid > 0) {
                        ClearPTK(priv_p, sta_p->asoc.adAddr, sta_p->keyId);
                        leave_assoc_state(priv_p, sta_p);
                }
        }
        return 0; /* success */

}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_deauth_sta(void *dev, unsigned char *macAddr)
{
        return cmd_deauth_sta_with_reason(dev, macAddr, SYN_auth_not_valid);
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_macPort_ctl(void *dev, unsigned char *macAddr, int block)
{
        i2220mgmt_t *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        sta_info_t  *sta_p;

        if (sdl_isBcst(macAddr)) {
                priv_p->rsnBlockingTraffic = block;
                return 0; /* Success */
        }
        else if ((sta_p = task_sta_lookup(priv_p, macAddr)) != NULL) {
                sta_p->rsnBlockingTraffic = block;
                return 0; /* Success */
        }
        return -1;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_set_RsnIE(void *dev, unsigned char *ie, int size)
{
        i2220mgmt_t     *priv_p = kal_dev_priv((kal_net_device_t*)dev);

        if (size < 0 || size > 80)
                return -1;

        ipn_memset(priv_p->addIE, 0, 80); /* For some old code */
        ipn_memcpy(priv_p->addIE, ie, size);
        priv_p->addIE_len = size;

        return 0; /* Success */
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int cmd_set_macKey(void *dev, unsigned char *macAddr, cmd_key_t *key_p)
{
        i2220mgmt_t             *priv_p = kal_dev_priv((kal_net_device_t*)dev);
        int                     retVal;

        if (key_p->cipherMode == CipherMode_NONE) {
                /* Clear the entry in security table */
                retVal = sdl_isGroup(macAddr) ?
                         ClearGTK(priv_p, key_p->keyId) :
                         ClearPTK(priv_p, macAddr, key_p->keyId);
        }
        else {
                retVal = sdl_isGroup(macAddr) ?
                         SetGTK(priv_p, key_p) :
                         SetPTK(priv_p, macAddr, key_p);
        }

        return retVal;
}

/*----------------------------------------------------------------*/
/*!
* \brief The PROC read function for Access Point mib parameters.
*
* This service handles user read the Accees Point MIB Setting.
* including SSID, baacon period, DTIM period,... etc.
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  total length of added strings.
*/
/*----------------------------------------------------------------*/
int wlan_read_config(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     * priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        UINT8           i, str[33];

        if (priv_p->stop_accept_station) {
                p+=sprintf(p,"Access Point       = Disabled\n");
        }
        else {
                p+=sprintf(p,"Access Point       = Enabled\n");
        }
#if SUPPORT_MSSID
        p+=sprintf(p,"No. Enabled? PRI VLAN_ID  VLAN Enabled?  SSID\n");
        for(i = 0 ;i < MAX_SSID ; i++){
                ssid_info_t* ssid_p;
                ssid_p = &priv_p->ap.ssid_list[i];
                ipn_memcpy(str, ssid_p->ssid, ssid_p->ssid_len);
                str[ssid_p->ssid_len] = 0; /* String NULL terminator */
                p+=sprintf(p,"%d   %s       %3d   %4d           %s       %s\n",i,
                        ssid_p->enabled?"T":"F", ssid_p->priority, ssid_p->vlanid,ssid_p->vlan_tag_enabled?"T":"F",str);
        }
#else
        ipn_memcpy(str, mib_import(dot11DesiredSSID.ssid), mib_import(dot11DesiredSSID.ssidLen));
        str[mib_import(dot11DesiredSSID.ssidLen)] = 0; /* String NULL terminator */
        p+=sprintf(p,"SSID               = %s\n", str);
#endif
        p+=sprintf(p,"Channel            = %d (0:auto)\n", mib_import(dot11CurrentChannel));
        p+=sprintf(p,"SupportRates(Mbps) =");
        for (i = 0; i < mib_import(dot11OperationalRateSet.rateSetSize); i++) {
                p+=sprintf(p," %d", (mib_import(dot11OperationalRateSet.rateSet[i]) & 0x7F)>>1);
                if (mib_import(dot11OperationalRateSet.rateSet[i]) & 0x01) {
                        p+=sprintf(p,".5");     /* for 5.5Mbps */
                }
                if (mib_import(dot11OperationalRateSet.rateSet[i]) & 0x80) {
                        p+=sprintf(p,"*");      /* basic rate */
                }
        }
        p+=sprintf(p,"\n");
        p+=sprintf(p,"Beacon Interval    = %d (TU)\n", mib_import(dot11BeaconPeriod));
        p+=sprintf(p,"DTIM Period        = %d\n", mib_import(dot11DTIMPeriod));
        p+=sprintf(p,"RTS Threshold      = %d\n", mib_import(dot11RTSThreshold));
        p+=sprintf(p,"Frag Threshold     = %d\n", mib_import(dot11FragmentationThreshold));
        p+=sprintf(p,"Tx Rate            = %d Mbps (0:auto)\n",
                priv_p->fixedTxRate_p ? priv_p->fixedTxRate_p->txRate>>1 : 0);
        p+=sprintf(p,"CTS Protect Mode   = %d (0:auto,1:always,2:none)\n", priv_p->protectMode);
        p+=sprintf(p,"Preamble Mode      = %d (0:auto,1:long,2:short)\n", priv_p->preambleMode);
        p+=sprintf(p,"Tx Burst Mode      = %d (0:disable,1:enable)\n", priv_p->x_CfbBurst);
        p+=sprintf(p,"Hidden SSID        = %d (0:disable,1:enable)\n", priv_p->x_hide_ssid);
        p+=sprintf(p,"Auth Mode          = %d (0:open,1:shared,2:switch,3:1x,4:wpa,5:wpa-psk)\n",
                priv_p->authMode);
        p+=sprintf(p,"Cipher Mode        = %d (0:no,1:wep40,2:tkip,4:ccmp,5:wep104,6:wep128)\n",
                priv_p->BCcipherSuite);
        p+=sprintf(p,"\n");

        return (p - output_str);
}

/*----------------------------------------------------------------*/
/*!
* \brief The PROC AP infomation read function .
*
* This service handles user read the Accees Point mib information.
* including Mac Address, RTSThreadhold, ShortRetryLimit, LongRetryLimit
* MaxTransmitMSDULifetime, MaxReceiveLifetime, ManufacturerID,
* and ProductID
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  no use.
*/
/*----------------------------------------------------------------*/
int wlan_read_info(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     *priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        ap_info_t       *ap = &priv_p->ap;
        int             sta_num = 0;
        struct list_head *lst;
        int             i;

        p+=sprintf(p,"HwAddr               = "MACSTR"\n",
                MAC2STR(mib_import(dot11MACAddress)));
        p+=sprintf(p,"Current channel      = %d (%s)\n", priv_p->curChannel,
                priv_p->channelBand ? "5GHz" : "2.4GHz");
#if SUPPORT_802_11A
        p+=sprintf(p,"Available channels   = %d",
                priv_p->numOperatingChannels24 + priv_p->numOperatingChannels5);
#else
        p+=sprintf(p,"Available channels   = %d",
                priv_p->numOperatingChannels24);
#endif
        p+=sprintf(p,"\n  -->(2.4GHz)");
        for (i = 0; i < priv_p->numOperatingChannels24; i++) {
                p+=sprintf(p," %d", priv_p->operatingChannels24[i]);
        }
#if SUPPORT_802_11A
        p+=sprintf(p,"\n  -->(5GHz)");
        for (i = 0; i < priv_p->numOperatingChannels5; i++) {
                p+=sprintf(p," %d", priv_p->operatingChannels5[i]);
        }
#endif
        p+=sprintf(p,"\n\n");

        list_for_each(lst, &ap->sta_chain.head) {
                sta_info_t      *sta_p;
                sta_p = list_entry(lst, sta_info_t, sw.link);
                if (sta_p->aid > 0) {
                        sta_num++;
                }
        }
        p+=sprintf(p,"Record_num           = %d\n", chain_num_elem(&ap->sta_chain));
        p+=sprintf(p,"bss_nonERP           = %d\n", priv_p->bss_nonERP);
        p+=sprintf(p,"sta_num(associated)  = %d\n", sta_num);
        p+=sprintf(p,"  -->sta_sleeping    = %d\n", priv_p->sta_sleeping);
        p+=sprintf(p,"  -->sta_LngPreamble = %d\n", priv_p->sta_LngPreamble);
        p+=sprintf(p,"  -->sta_nonERP      = %d\n", priv_p->sta_nonERP);
        p+=sprintf(p,"  -->sta_LngSlotTime = %d\n", priv_p->sta_LngSlotTime);
        p+=sprintf(p,"\n");

        p+=sprintf(p,"macDoggyCount        = %d (%d,%d,%d,%d)\n",
                priv_p->macResetCount, priv_p->macResetBcnCount,
                priv_p->macResetUFIFOCount, priv_p->macResetAbnormalCount,
                priv_p->macResetRxEmpty);

#if SUPPORT_ED_ADJUST
        p+=sprintf(p,"dirty_state          = %d\n", priv_p->state_noise);
        p+=sprintf(p,"  -->float_level     = %d\n", priv_p->ED_floatLevel);
        p+=sprintf(p,"  -->cur_EDThd       = %d\n\n", priv_p->cur_EDThreshold);
#endif
        p+=sprintf(p,"primaryTxAntenna     = %d\n", priv_p->primaryTxAntenna);
        p+=sprintf(p,"currentTxAntenna     = %d\n", priv_p->currentTxAntenna);
        p+=sprintf(p,"primaryRxAntenna     = %d\n", priv_p->primaryRxAntenna);
        p+=sprintf(p,"  -->rxAntenna       = %1lx (1:P,2:S,f:diversity)\n",
                                        priv_p->mib.dot11CurrentRxAntenna);
        p+=sprintf(p,"\n");

        return (p - output_str);
}

/*----------------------------------------------------------------*/
/*!
* \brief The Access Point PROC for general Statistic read function .
*
* This service handles user read the Accees Point general information.
* including RfbRxOkCounter, RFCrcErr, TransmittedFragmentCount
* MulticastTransmittedFrameCount, FailedCount, RetryCount, MultipleRetryCount
* FrameDuplicateCount ... etc.
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  no use.
*/
/*----------------------------------------------------------------*/
int wlan_read_stat(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     *priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        UINT32          temp32;

/* TX MSDU */
        p+=sprintf(p,"TransmittedFrameCount(OK)      = %lu\n",mib_import(dot11TransmittedFrameCount));
        p+=sprintf(p,"MulticastTransmittedFrameCount = %lu\n",mib_import(dot11MulticastTransmittedFrameCount));
        p+=sprintf(p,"FailedCount                    = %lu\n",mib_import(dot11FailedCount));
        p+=sprintf(p,"\n");
/* TX MPDU */
        p+=sprintf(p,"txTfcbTxOkCounter              = %u\n",priv_p->hwStatistics.txTfcbTxOkCounter);
        p+=sprintf(p,"txTfcbTxErrCounter             = %u\n",priv_p->hwStatistics.txTfcbTxErrCounter);
        p+=sprintf(p,"TransmittedFragmentCount(OK)   = %lu\n",mib_import(dot11TransmittedFragmentCount));
        p+=sprintf(p,"  --> RetryCount               = %lu\n",mib_import(dot11RetryCount));
        p+=sprintf(p,"  --> MultipleRetryCount       = %lu\n",mib_import(dot11MultipleRetryCount));
        p+=sprintf(p,"ACKFailureCount                = %lu\n",mib_import(dot11ACKFailureCount));
        p+=sprintf(p,"RTSSuccessCount                = %lu\n",mib_import(dot11RTSSuccessCount));
        p+=sprintf(p,"RTSFailureCount                = %lu\n",mib_import(dot11RTSFailureCount));
        p+=sprintf(p,"\n");
/* RX */
        p+=sprintf(p,"RfbRxOkCounter                 = %u\n",priv_p->hwStatistics.rxRfbRxOkCounter);
        p+=sprintf(p,"ReceivedFragmentCount          = %lu\n",mib_import(dot11ReceivedFragmentCount));
        p+=sprintf(p,"MulticastReceivedFrameCount    = %lu\n",mib_import(dot11MulticastReceivedFrameCount));
        p+=sprintf(p,"FrameDuplicateCount            = %lu\n",mib_import(dot11FrameDuplicateCount));

        NIC_MCR_READ(priv_p, MCR_RPCR, &temp32);
        priv_p->hwStatistics.rxPacketCount += temp32;
        p+=sprintf(p,"RxMdrdyCount                   = %llu\n",priv_p->hwStatistics.rxPacketCount);
        NIC_MCR_READ(priv_p, MCR_RFECR, &temp32);
        mib_import(dot11FCSErrorCount) += temp32;
        p+=sprintf(p,"FCSErrorCount                  = %lu\n",mib_import(dot11FCSErrorCount));
        NIC_MCR_READ(priv_p, MCR_RFFCR, &temp32);
        priv_p->hwStatistics.RcvFifoFulls += temp32;
        p+=sprintf(p,"RxFifoFullCount                = %u\n",priv_p->hwStatistics.RcvFifoFulls);

        p+=sprintf(p,"\n");
        return (p - output_str);
}

/*----------------------------------------------------------------*/
/*!
* \brief The PROC for read Access Point Physical registers.
*
* This service handles user read the Accees Point Physical registers.
* Not support right now.
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  no use.
*/
/*----------------------------------------------------------------*/
int wlan_read_eeprom(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     *priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        UINT16          offset, eepromWordValue;

        p += sprintf(p, "EEPROM Size = 512 Bytes");

        for (offset = 0; offset < 512; offset += 2) {
                if ((offset % 16) == 0) {
                        p += sprintf(p, "\n0x%04x:", offset);
                }
                eepromWordValue = ReadEEProm16(priv_p, offset>>1);
                p += sprintf(p, " %04x", eepromWordValue);
        }
        p += sprintf(p, "\n");

        return (p - output_str);
}

/*----------------------------------------------------------------*/
/*!
* \brief The PROC for read Access Point Physical registers.
*
* This service handles user read the Accees Point Physical registers.
* Not support right now.
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  no use.
*/
/*----------------------------------------------------------------*/
int wlan_read_mcr(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     *priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        UINT32          offset, tmpUlong;

        for (offset = 0; offset < 0x04FF; offset += 4) {
                if ((offset % 16) == 0) {
                        p += sprintf(p, "\n0x%04lx:", offset);
                }
                NIC_MCR_READ(priv_p, offset, &tmpUlong);
                p += sprintf(p, " %08lx", tmpUlong);
        }
        p += sprintf(p, "\n");

        return (p - output_str);
}

/*----------------------------------------------------------------*/
/*!
* \brief The PROC for read Access Point mmi parameters.
*
* This service handles user read the Accees Point configuration.
* Not support right now.
* This procedure only present when WLAN_INCLUDE_PROC=1
*
* \param   the PROC CONST defined parameters
* \return  no use.
*/
/*----------------------------------------------------------------*/
int wlan_read_bcr(void* dev, char *output_str)
{
        char            *p = output_str;
        kal_net_device_t* net_dev = (kal_net_device_t*)dev;
        i2220mgmt_t     *priv_p = (i2220mgmt_t*)kal_dev_priv(net_dev);
        UINT32          index;
        UINT8           tmp8;

        for (index = 0; index < 0x0080; index++) {
                if ((index % 16) == 0) {
                        p += sprintf(p, "\n0x%04lx:", index);
                }
                BCIRead8(priv_p, index, &tmp8, TRUE, 0xff);
                p += sprintf(p, " %02x", tmp8);
        }
        p += sprintf(p, "\n");

        return (p - output_str);
}
