/*
** $Id: 80211mib.h 1.18 2004/10/04 17:21:46 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

#ifndef _80211MIB_H
#define _80211MIB_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
/* IEEE 802.11 MIB ID definitions */
#define MIB_DOT_11_STATION_ID               0x01010101  /* dot11StationID */
#define MIB_DOT_11_MEDIUM_OCC_LIMIT         0x01010102  /* dot11MediumOccupancyLimit */
#define MIB_DOT_11_CF_POLLABLE              0x01010103  /* dot11CFPollable */
#define MIB_DOT_11_CFP_PERIOD               0x01010104  /* dot11CFPPeriod */
#define MIB_DOT_11_CFP_MAX_DURATION         0x01010105  /* dot11CFPMaxDuration */
#define MIB_DOT_11_AUTH_RSP_TIME_OUT        0x01010106  /* dot11AuthenticationResponseTimeOut */
#define MIB_DOT_11_PRIVACY_OP_IMP           0x01010107  /* dot11PrivacyOptionalImplemented */
#define MIB_DOT_11_POWER_MGT_MODE           0x01010108  /* dot11PowerManagementMode */
#define MIB_DOT_11_DESIRED_SSID             0x01010109  /* dot11DesiredSSID */
#define MIB_DOT_11_DESIRED_BSS_TYPE         0x0101010A  /* dot11DesiredBSSType */
#define MIB_DOT_11_OP_RATE_SET              0x0101010B  /* dot11OperationalRateSet */
#define MIB_DOT_11_BEACON_PERIOD            0x0101010C  /* dot11BeaconPeriod */
#define MIB_DOT_11_DTIM_PERIOD              0x0101010D  /* dot11DTIMPeriod */
#define MIB_DOT_11_ASSOC_RSP_TIME_OUT       0x0101010E  /* dot11AssociationResponseTimeOut */
#define MIB_DOT_11_DISASSOC_REASON          0x0101010F  /* dot11DisassociateReason */
#define MIB_DOT_11_DISASSOC_STATION         0x01010110  /* dot11DisassociateStation */
#define MIB_DOT_11_DEAUTH_REASON            0x01010111  /* dot11DeauthenticateReason */
#define MIB_DOT_11_DEAUTH_STATION           0x01010112  /* dot11DeauthenticateStation */
#define MIB_DOT_11_AUTH_FAIL_STATUS         0x01010113  /* dot11AuthenticateFailStatus */
#define MIB_DOT_11_AUTH_FAIL_STATION        0x01010114  /* dot11AuthenticateFailStation */

#define MIB_DOT_11_AUTH_ALG_INDEX           0x01020101  /* dot11AuthenticationAlgorithmsIndex */
#define MIB_DOT_11_AUTH_ALG                 0x01020102  /* dot11AuthenticationAlgorithm */
#define MIB_DOT_11_AUTH_ALG_ENABLE          0x01020103  /* dot11AuthenticationAlgorithmsEnable */

#define MIB_DOT_11_UNICASTER_CIPHER         0x01020104  //  Notice ..............................//
#define MIB_DOT_11_WEP_ON_OFF               0x01020105  //  Notice ..............................//
#if SUPPORT_IPNRSN
#define MIB_DOT_11_RSN_PSK_1X               0x01020106  //  Notice ..............................//
#endif
#define MIB_DOT_11_PURE_1X                  0x01020107

#define MIB_DOT_11_WEP_DEFAULT_KEY_INDEX    0x01030101  /* dot11WEPDefaultKeyIndex */
#define MIB_DOT_11_WEP_DEFAULT_KEY_VALUE    0x01030102  /* dot11WEPDefaultKeyValue */

#define MIB_DOT_11_WEP_KEY_MAPPING_INDEX    0x01040101  /* dot11WEPKeyMappingIndex */
#define MIB_DOT_11_WEP_KEY_MAPPING_ADDRESS  0x01040102  /* dot11WEPKeyMappingAddress */
#define MIB_DOT_11_WEP_KEY_MAPPING_WEP_ON   0x01040103  /* dot11WEPKeyMappingWEPOn */
#define MIB_DOT_11_WEP_KEY_MAPPING_VALUE    0x01040104  /* dot11WEPKeyMappingValue */
#define MIB_DOT_11_WEP_KEY_MAPPING_STATUS   0x01040105  /* dot11WEPKeyMappingStatus */

#define MIB_DOT_11_PRIVACY_INVOKED          0x01050101  /* dot11PrivacyInvoked */
#define MIB_DOT_11_WEP_DEFAULT_KEY_ID       0x01050102  /* dot11WEPDefaultKeyID */
#define MIB_DOT_11_WEP_KEY_MAPPING_LENGTH   0x01050103  /* dot11WEPKeyMappingLength */
#define MIB_DOT_11_EXCLUDE_UNENCRYPTED      0x01050104  /* dot11ExcludeEncrypted */
#define MIB_DOT_11_WEP_ICV_ERROR_COUNT      0x01050105  /* dot11WEPICVErrorCount */
#define MIB_DOT_11_WEP_EXCLUDED_COUNT       0x01050106  /* dot11WEPExcludedCount */

#define MIB_DOT_11_MAC_ADDRESS              0x02010101  /* dot11MACAddress */
#define MIB_DOT_11_RTS_THRESHOLD            0x02010102  /* dot11RTSThreshold */
#define MIB_DOT_11_SHORT_RETRY_LIMIT        0x02010103  /* dot11ShortRetryLimit */
#define MIB_DOT_11_LONG_RETRY_LIMIT         0x02010104  /* dot11LongRetryLimit */
#define MIB_DOT_11_FRAG_THRESHOLD           0x02010105  /* dot11FragmentationThreshold */
#define MIB_DOT_11_MAX_TX_MSDU_LIFETIME     0x02010106  /* dot11MaxTransmitMSDULifetime */
#define MIB_DOT_11_MAX_RX_LIFETIME          0x02010107  /* dot11MaxReceiveLifetime */
#define MIB_DOT_11_MANUF_ID                 0x02010108  /* dot11ManufacturerID */
#define MIB_DOT_11_PRODUCT_ID               0x02010109  /* dot11ProductID */

#define MIB_DOT_11_TX_FRAG_COUNT            0x02020101  /* dot11TransmittedFragmentCount */
#define MIB_DOT_11_MC_TX_FRAME_COUNT        0x02020102  /* dot11MulticastTransmittedFrameCount */
#define MIB_DOT_11_FAILED_COUNT             0x02020103  /* dot11FailedCount */
#define MIB_DOT_11_RETRY_COUNT              0x02020104  /* dot11RetryCount */
#define MIB_DOT_11_MULTIPLE_RETRY_COUNT     0x02020105  /* dot11MultipleRetryCount */
#define MIB_DOT_11_FRAME_DUPLICATE_COUNT    0x02020106  /* dot11FrameDuplicateCount */
#define MIB_DOT_11_RTS_SUCCESS_COUNT        0x02020107  /* dot11RTSSuccessCount */
#define MIB_DOT_11_RTS_FAILURE_COUNT        0x02020108  /* dot11RTSFailureCount */
#define MIB_DOT_11_ACK_FAILURE_COUNT        0x02020109  /* dot11ACKFailureCount */
#define MIB_DOT_11_RX_FRAG_COUNT            0x0202010A  /* dot11ReceivedFragmentCount */
#define MIB_DOT_11_MC_RX_FRAME_COUNT        0x0202010B  /* dot11MulticastReceivedFrameCount */
#define MIB_DOT_11_FCS_ERROR_COUNT          0x0202010C  /* dot11FCSErrorCount */
#define MIB_DOT_11_TX_FRAME_COUNT           0x0202010D  /* dot11TransmittedFrameCount */
#define MIB_DOT_11_WEP_UNDECRYPTABLE_COUNT  0x0202010E  /* dot11WEPUndecryptableCount */

#define MIB_DOT_11_GROUP_ADDRESSES_INDEX    0x02030101  /* dot11GroupAddressesIndex */
#define MIB_DOT_11_ADDRESS                  0x02030102  /* dot11Address */
#define MIB_DOT_11_GROUP_ADDRESSES_STATUS   0x02030103  /* dot11GroupAddressesStatus */

#define MIB_DOT_11_RESOURCE_TYPE_ID_NAME    0x03010100  /* dot11ResourceTypeIDName */

#define MIB_DOT_11_MANUF_OUI                0x03010201  /* dot11manufacturerOUI */
#define MIB_DOT_11_MANUF_NAME               0x03010202  /* dot11manufacturerName */
#define MIB_DOT_11_MANUF_PRODUCT_NAME       0x03010203  /* dot11manufacturerProductName */
#define MIB_DOT_11_MANUF_PRODUCT_VERSION    0x03010204  /* dot11manufacturerProductVersion */

#define MIB_DOT_11_PHY_TYPE                 0x04010101  /* dot11PHYType */
#define MIB_DOT_11_CURRENT_REG_DOMAIN       0x04010102  /* dot11CurrentRegDomain */
#define MIB_DOT_11_TEMP_TYPE                0x04010103  /* dot11TempType */

#define MIB_DOT_11_CURRENT_TX_ANTENNA       0x04020101  /* dot11CurrentTxAntenna */
#define MIB_DOT_11_DIVERSITY_SUP            0x04020102  /* dot11DiversitySupport */
#define MIB_DOT_11_CURRENT_RX_ANTENNA       0x04020103  /* dot11CurrentRxAntenna */

#define MIB_DOT_11_NUM_SUP_POWER_LEVELS     0x04030101  /* dot11NumberSupportedPowerLevels */
#define MIB_DOT_11_TX_POWER_LEVEL_1         0x04030102  /* dot11TxPowerLevel1 */
#define MIB_DOT_11_TX_POWER_LEVEL_2         0x04030103  /* dot11TxPowerLevel2 */
#define MIB_DOT_11_TX_POWER_LEVEL_3         0x04030104  /* dot11TxPowerLevel3 */
#define MIB_DOT_11_TX_POWER_LEVEL_4         0x04030105  /* dot11TxPowerLevel4 */
#define MIB_DOT_11_TX_POWER_LEVEL_5         0x04030106  /* dot11TxPowerLevel5 */
#define MIB_DOT_11_TX_POWER_LEVEL_6         0x04030107  /* dot11TxPowerLevel6 */
#define MIB_DOT_11_TX_POWER_LEVEL_7         0x04030108  /* dot11TxPowerLevel7 */
#define MIB_DOT_11_TX_POWER_LEVEL_8         0x04030109  /* dot11TxPowerLevel8 */
#define MIB_DOT_11_CURRENT_TX_POWER_LEVEL   0x0403010A  /* dot11CurrentTxPowerLevel */

#define MIB_DOT_11_CURRENT_CHANNEL          0x04050101  /* dot11CurrentChannel */
#define MIB_DOT_11_CCA_MODE_SUP             0x04050102  /* dot11CCAModeSupported */
#define MIB_DOT_11_CURRENT_CCA_MODE         0x04050103  /* dot11CurrentCCAMode */
#define MIB_DOT_11_ED_THRESHOLD             0x04050104  /* dot11EDThreshold */

#define MIB_DOT_11_REG_DOMAINS_SUP_INDEX    0x04070101  /* dot11RegDomainsSupportIndex */
#define MIB_DOT_11_REG_DOMAINS_SUP_VALUE    0x04070102  /* dot11RegDomainsSupportValue */

#define MIB_DOT_11_ANTENNA_LIST_INDEX       0x04080101  /* dot11AntennaListIndex */
#define MIB_DOT_11_SUP_TX_ANTENNA           0x04080102  /* dot11SupportedTxAntenna */
#define MIB_DOT_11_SUP_RX_ANTENNA           0x04080103  /* dot11SupportedRxAntenna */
#define MIB_DOT_11_DIVERSITY_SELECTION_RX   0x04080104  /* dot11DiversitySelectionRx */

#define MIB_DOT_11_SUP_DATA_RATES_TX_INDEX  0x04090101  /* dot11SupportedDataRatesTxIndex */
#define MIB_DOT_11_SUP_DATA_RATES_TX_VALUE  0x04090102  /* dot11SupportedDataRatesTxValue */

#define MIB_DOT_11_SUP_DATA_RATES_RX_INDEX  0x040A0101  /* dot11SupportedDataRatesRxIndex */
#define MIB_DOT_11_SUP_DATA_RATES_RX_VALUE  0x040A0102  /* dot11SupportedDataRatesRxValue */

#if SUPPORT_IPNRSN
#define MIB_DOT_11_RSN_PAIRWISE_REKEY       0x040B0101  /* dot11RSNConfigGroupMasterRekeyTime*/
#define MIB_DOT_11_RSN_Group_REKEY_TIME     0x040B0102  /* dot11RSNConfigGroupMasterRekeyTime*/
#endif

/* programmable parameters for MIBs */
#define MAX_NUM_AUTH_ALGORITHM          2   /* max number of auth algorithms */
#define MAX_NUM_GROUP_ADDR              32  /* max number of group addresses */
#define MAX_NUM_SUPPORTED_REG_DOMAIN    8   /* max number of supported regulatory domains */
#define MAX_NUM_ANTENNA                 2   /* max number of antennas */
#define MAX_NUM_QOS_TRAFFIC             1   /* max number of QoS traffic */

#define KEY_LEN                         16   /* key length: 16 bytes (128 bits) */
#define WEP_KEY_LEN                     19   /* WEP key length: 16 bytes (128 bits) */
#define RSN_KEY_LEN                     32   /* RSN key length: include send and receive integrity keys */
#define WEP_KEY_DEFAULT_LEN              4   /* Default key length */
#define WEP_KEY_MAPPING_LEN            124   /* dot11WEPKeyMappingLength */
#define UINCAST_CIPHER_SUITE_COUNT       8
#define AUTHENTICATION_SUITE_COUNT       3

#define WEP_NULL_KEY \
        { \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  \
        }
#define RSN_NULL_KEY \
        { \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  \
        }

#define MIB_CWMIN                       15      /* default aCWmin */
#define MIB_CWMAX                       1023    /* default aCWMax */

/* dot11PowerManagementMode */
#define MIB_PWR_MGT_MODE_ACTIVE         1   /* active */
#define MIB_PWR_MGT_MODE_PS             2   /* powersave */

/* dot11AuthenticationAlgorithmsTable */
#define MIB_AUTH_ALGORITHM_OPEN_SYSTEM  1   /* open system */
#define MIB_AUTH_ALGORITHM_SHARED_KEY   2   /* shared key */

/* dot11PHYType */
#define MIB_PHY_TYPE_FHSS               1   /* FHSS */
#define MIB_PHY_TYPE_DSSS               2   /* DSSS */
#define MIB_PHY_TYPE_IR_BASEBAND        3   /* IR baseband */
#define MIB_PHY_TYPE_OFDM               4   /* OFDM */
#define MIB_PHY_TYPE_HRDSSS             5   /* HRDSSS */
#define MIB_PHY_TYPE_ERP                6   /* ERP */

/* dot11TempType */
#define MIB_TEMP_TYPE_1                 1   /* tempType1 */
#define MIB_TEMP_TYPE_2                 2   /* tempType2 */

/* dot11DiversitySupport */
#define MIB_DIVERSITY_FIXED_LIST        1   /* fixedlist */
#define MIB_DIVERSITY_NOT_SUPPORTED     2   /* notsupported */
#define MIB_DIVERSITY_DYNAMIC           3   /* dynamic */

/* dot11CCAModeSupported */
#define MIB_CCA_MODE_ED_ONLY            0x01    /* edonly */
#define MIB_CCA_MODE_CS_ONLY            0x02    /* csonly */
#define MIB_CCA_MODE_ED_AND_CS          0x04    /* edandcs */
#define MIB_CCA_MODE_CS_WITH_TIMER      0x08    /* cswithtimer */
#define MIB_CCA_MODE_HR_CS_AND_ED       0x10    /* hrcsanded */

#if 0 /* Move to wlan_lib.h */
/* dot11RegDomainsSupportValue */
#define MIB_REG_DOMAIN_FCC              0x10    /* FCC (US) */
#define MIB_REG_DOMAIN_IC               0x20    /* IC or DOC (Canada) */
#define MIB_REG_DOMAIN_ETSI             0x30    /* ETSI (Europe) */
#define MIB_REG_DOMAIN_SPAIN            0x31    /* Spain */
#define MIB_REG_DOMAIN_FRANCE           0x32    /* France */
#define MIB_REG_DOMAIN_JAPAN_1          0x40    /* MPHPT (Japan) Channel 14 */
#define MIB_REG_DOMAIN_JAPAN_2          0x41    /* MPHPT (Japan) Channel 1 to 13 */
#endif

/* dot11FrequencyBandsSupported */
#define MIB_U_NII_BAND_LOWER            0x00000001  /* lower (5.15-5.25 GHz) U-NII band */
#define MIB_U_NII_BAND_MIDDLE           0x00000002  /* middle (5.25-5.35 GHz) U-NII band */
#define MIB_U_NII_BAND_UPPER            0x00000004  /* upper (5.725-5.825 GHz) U-NII band */

/* dot11AntennaListIndex */
#define MIB_ANTENNA_PRIMARY             1           /* primary antenna */
#define MIB_ANTENNA_SECONDARY           2           /* secondary antenna */
#define MIB_ANTENNA_DIVERSITY           0xffffffff  /* antenna diversity */


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/
//#pragma pack(1)
/* IEEE 802.11i Suite Selector */
typedef struct _SUITE_SELECTOR {
    union {
        ULONG suiteSelector;
        struct {
            UCHAR oui[3];
            UCHAR type;
        }s;
    }u;
} SUITE_SELECTOR, *PSUITE_SELECTOR;
//#pragma pack()
#if 0
/* Entry in SMT Station Config Table: dot11StationConfigEntry */
typedef struct _DOT11_STATION_CONFIG_ENTRY {
    UCHAR       dot11StationID[6];          /* dot11StationConfigEntry 1 */
    USHORT      dot11MediumOccupancyLimit;  /* dot11StationConfigEntry 2 */
    BOOLEAN     dot11CFPollable;            /* dot11StationConfigEntry 3 */
    UCHAR       dot11CFPPeriod;             /* dot11StationConfigEntry 4 */
    USHORT      dot11CFPMaxDuration;        /* dot11StationConfigEntry 5 */
    ULONG       dot11AuthenticationResponseTimeOut; /* dot11StationConfigEntry 6 */
    BOOLEAN     dot11PrivacyOptionImplemented;      /* dot11StationConfigEntry 7 */
    UCHAR       dot11PowerManagementMode;   /* dot11StationConfigEntry 8 */
    struct {
        UCHAR   ssidLen;
        UCHAR   ssid[33];
    } dot11DesiredSSID;                     /* dot11StationConfigEntry 9 */
    UCHAR       dot11DesiredBSSType;        /* dot11StationConfigEntry 10 */
    struct {
        UCHAR   rateSetSize;
        UCHAR   rateSet[MAX_NUM_SUPPORTED_DATA_RATES];
    } dot11OperationalRateSet;              /* dot11StationConfigEntry 11 */
    USHORT      dot11BeaconPeriod;          /* dot11StationConfigEntry 12 */
    UCHAR       dot11DTIMPeriod;            /* dot11StationConfigEntry 13 */
    ULONG       dot11AssociationResponseTimeOut;    /* dot11StationConfigEntry 14 */
    USHORT      dot11DisassociateReason;    /* dot11StationConfigEntry 15 */
    UCHAR       dot11DisassociateStation[6];        /* dot11StationConfigEntry 16 */
    USHORT      dot11DeauthenticateReason;  /* dot11StationConfigEntry 17 */
    UCHAR       dot11DeauthenticateStation[6];      /* dot11StationConfigEntry 18 */
    USHORT      dot11AuthenticateFailStatus;        /* dot11StationConfigEntry 19 */
    UCHAR       dot11AuthenticateFailStation[6];    /* dot11StationConfigEntry 20 */
#if SUPPORT_IPNRSN
    BOOLEAN     dot11RSNOptionImplemented;          /* dot11StationConfigEntry 24, new added for RSN */
#endif /* SUPPORT_RSN */
} DOT11_STATION_CONFIG_ENTRY, *PDOT11_STATION_CONFIG_ENTRY;
#endif
/* Entry in SMT AuthenticationAlgorithms Table: dot11AuthenticationAlgorithmsEntry */
typedef struct _DOT11_AUTHENTICATION_ALGORITHMS_ENTRY {
    ULONG       dot11AuthenticationAlgorithmsIndex;  /* dot11AuthenticationAlgorithmsEntry 1 */
    USHORT      dot11AuthenticationAlgorithm;        /* dot11AuthenticationAlgorithmsEntry 2 */
    BOOLEAN     dot11AuthenticationAlgorithmsEnable; /* dot11AuthenticationAlgorithmsEntry 3 */
} DOT11_AUTHENTICATION_ALGORITHMS_ENTRY, *PDOT11_AUTHENTICATION_ALGORITHMS_ENTRY;

/* Entry in SMT WEPDefaultKeys Table: dot11WEPDefaultKeysEntry */
typedef struct _DOT11_WEP_DEFAULT_KEYS_ENTRY {
    ULONG       dot11WEPDefaultKeyIndex;              /* dot11WEPDefaultKeysEntry 1 */
#if SUPPORT_IPNRSN | SUPPORT_WPA2
    UCHAR       dot11WEPDefaultKeyValue[RSN_KEY_LEN]; /* dot11WEPDefaultKeysEntry 2 */
    ULONG       dot11WEPDefaultKeySize;               /* dot11WEPDefaultKeyEntry, new added for RSN */
#else
    UCHAR       dot11WEPDefaultKeyValue[RSN_KEY_LEN]; /* dot11WEPDefaultKeysEntry 2 */
#endif /* SUPPORT_RSN */
} DOT11_WEP_DEFAULT_KEYS_ENTRY, *PDOT11_WEP_DEFAULT_KEYS_ENTRY;

#if 0
/* Entry in SMT WEPKeyMappings Table: dot11WEPKeyMappingsEntry */
typedef struct _DOT11_WEP_KEY_MAPPINGS_ENTRY {
    ULONG       dot11WEPKeyMappingIndex;              /* dot11WEPKeyMappingsEntry 1 */
    UCHAR       dot11WEPKeyMappingAddress[6];         /* dot11WEPKeyMappingsEntry 2 */
    BOOLEAN     dot11WEPKeyMappingWEPOn;              /* dot11WEPKeyMappingsEntry 3 */
#if SUPPORT_IPNRSN
    UCHAR       dot11WEPKeyMappingValue[RSN_KEY_LEN]; /* dot11WEPKeyMappingsEntry 4 */
    ULONG       dot11WEPKeyMappingStatus;             /* dot11WEPKeyMappingsEntry 5 */
    ULONG       dot11WEPKeyMappingSize;               /* dot11WEPKeyMappingsEntry, new added for RSN */
#else
    UCHAR       dot11WEPKeyMappingValue[WEP_KEY_LEN]; /* dot11WEPKeyMappingsEntry 4 */
    ULONG       dot11WEPKeyMappingStatus;             /* dot11WEPKeyMappingsEntry 5 */
#endif /* SUPPORT_RSN */
} DOT11_WEP_KEY_MAPPINGS_ENTRY, *PDOT11_WEP_KEY_MAPPINGS_ENTRY;
#endif
#if 0
/* Entry in SMT CCMPKeyMappings Table: dot11CcmpKeyMappingsEntry */
/* New add for RSN, CCMP */
typedef struct _DOT11_CCMP_KEY_MAPPINGS_ENTRY {
    UCHAR       dot11CcmpKeyID;                /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpReceiveAddress[6];    /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpTransmitAddress[6];   /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpTemporalKey[KEY_LEN]; /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpTrafficClassPacketNumber[MAX_NUM_QOS_TRAFFIC][6]; /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpTrafficClassReplayWindow[MAX_NUM_QOS_TRAFFIC][6]; /* dot11CcmpKeyMappingsEntry */
    BOOLEAN     dot11CcmpEnableTransmit; /* dot11CcmpKeyMappingsEntry */
    BOOLEAN     dot11CcmpEnableReceive;  /* dot11CcmpKeyMappingsEntry */
    ULONG       dot11CcmpFormatErrors;   /* dot11CcmpKeyMappingsEntry */
    ULONG       dot11CcmpReplays;        /* dot11CcmpKeyMappingsEntry */
    ULONG       dot11CcmpDecryptErrors;  /* dot11CcmpKeyMappingsEntry */
    UCHAR       dot11CcmpRecvdMPDU[6];   /* dot11CcmpKeyMappingsEntry */
} DOT11_CCMP_KEY_MAPPINGS_ENTRY, *PDOT11_CCMP_KEY_MAPPINGS_ENTRY;
#endif
#if 0
/* Entry in SMT WRAPKeyMappings Table: dot11WrapKeyMappingsEntry */
/* New add for RSN, WRAP */
typedef struct _DOT11_WRAP_KEY_MAPPINGS_ENTRY {
    UCHAR       dot11WrapKeyID;                   /* dot11WrapKeyMappingsEntry */
    UCHAR       dot11WrapReceiveAddress[6];       /* dot11WrapKeyMappingsEntry */
    UCHAR       dot11WrapTransmitAddress[6];      /* dot11WrapKeyMappingsEntry */
    UCHAR       dot11AESOCBTemporalKey[KEY_LEN];  /* dot11WrapKeyMappingsEntry */
    ULONG       dot11WrapTrafficClassSequenceCounter[MAX_NUM_QOS_TRAFFIC]; /* dot11WrapKeyMappingsEntry */
    UCHAR       dot11WrapBlocksSent[6];           /* dot11WrapKeyMappingsEntry */
    ULONG       dot11WrapTrafficClassReplayWindow[MAX_NUM_QOS_TRAFFIC];    /* dot11WrapKeyMappingsEntry */
    BOOLEAN     dot11WrapEnableTransmit; /* dot11WrapKeyMappingsEntry */
    BOOLEAN     dot11WrapEnableReceive;  /* dot11WrapKeyMappingsEntry */
    ULONG       dot11WrapFormatErrors;   /* dot11WrapKeyMappingsEntry */
    ULONG       dot11WrapReplays;        /* dot11WrapKeyMappingsEntry */
    ULONG       dot11WrapDecryptErrors;  /* dot11WrapKeyMappingsEntry */
    UCHAR       dot11WrapRecvdBlocks[6]; /* dot11WrapKeyMappingsEntry */
} DOT11_WRAP_KEY_MAPPINGS_ENTRY, *PDOT11_WRAP_KEY_MAPPINGS_ENTRY;
#endif
#if 0
/* Entry in SMT dot11PrivacyTable Table: dot11PrivacyEntry */
typedef struct _DOT11_PRIVACY_ENTRY {
    BOOLEAN     dot11PrivacyInvoked;        /* dot11PrivacyEntry 1 */
    ULONG       dot11WEPDefaultKeyID;       /* dot11PrivacyEntry 2 */
    ULONG       dot11WEPKeyMappingLength;   /* dot11PrivacyEntry 3 */
    BOOLEAN     dot11ExcludeUnencrypted;    /* dot11PrivacyEntry 4 */
    ULONG       dot11WEPICVErrorCount;      /* dot11PrivacyEntry 5 */
    ULONG       dot11WEPExcludedCount;      /* dot11PrivacyEntry 6 */
#if SUPPORT_IPNRSN
    BOOLEAN     dot11RSNEnabled;            /* dot11PrivacyEntry 7 */
    BOOLEAN     dot11HaveGTK;               /* dot11PrivacyEntry 8 */
    BOOLEAN     dot11HavePTK;               /* dot11PrivacyEntry 9 */
    BOOLEAN     dot11WEPKeyMappingsKeyBroadcast;/* dot11PrivacyEntry 10 */
#endif /* SUPPORT_RSN */
} DOT11_PRIVACY_ENTRY, *PDOT11_PRIVACY_ENTRY;
#endif
#if 0
/* Entry in MAC dot11OperationTable Table: dot11OperationEntry */
typedef struct _DOT11_OPERATION_ENTRY {
    UCHAR       dot11MACAddress[6];         /* dot11OperationEntry 1 */
    ULONG       dot11RTSThreshold;          /* dot11OperationEntry 2 */
    ULONG       dot11ShortRetryLimit;       /* dot11OperationEntry 3 */
    ULONG       dot11LongRetryLimit;        /* dot11OperationEntry 4 */
    ULONG       dot11FragmentationThreshold;        /* dot11OperationEntry 5 */
    ULONG       dot11MaxTransmitMSDULifetime;       /* dot11OperationEntry 6 */
    ULONG       dot11MaxReceiveLifetime;    /* dot11OperationEntry 7 */
    CHAR        dot11ManufacturerID[128];   /* dot11OperationEntry 8 */
    CHAR        dot11ProductID[128];        /* dot11OperationEntry 9 */
} DOT11_OPERATION_ENTRY, *PDOT11_OPERATION_ENTRY;
#endif
/* Entry in MAC dot11Counters Table: dot11CountersEntry */
typedef struct _DOT11_COUNTERS_ENTRY {
    ULONG       dot11TransmittedFragmentCount;          /* dot11CountersEntry 1 */
    ULONG       dot11MulticastTransmittedFrameCount;    /* dot11CountersEntry 2 */
    ULONG       dot11FailedCount;           /* dot11CountersEntry 3 */
    ULONG       dot11RetryCount;            /* dot11CountersEntry 4 */
    ULONG       dot11MultipleRetryCount;    /* dot11CountersEntry 5 */
    ULONG       dot11FrameDuplicateCount;   /* dot11CountersEntry 6 */
    ULONG       dot11RTSSuccessCount;       /* dot11CountersEntry 7 */
    ULONG       dot11RTSFailureCount;       /* dot11CountersEntry 8 */
    ULONG       dot11ACKFailureCount;       /* dot11CountersEntry 9 */
    ULONG       dot11ReceivedFragmentCount; /* dot11CountersEntry 10 */
    ULONG       dot11MulticastReceivedFrameCount;       /* dot11CountersEntry 11 */
    ULONG       dot11FCSErrorCount;         /* dot11CountersEntry 12 */
    ULONG       dot11TransmittedFrameCount; /* dot11CountersEntry 13 */
    ULONG       dot11WEPUndecryptableCount; /* dot11CountersEntry 14 */
} DOT11_COUNTERS_ENTRY, *PDOT11_COUNTERS_ENTRY;
#if 0
/* Entry in MAC GroupAddresses Table: dot11GroupAddressesEntry */
typedef struct _DOT11_GROUP_ADDRESSES_ENTRY {
    ULONG       dot11GroupAddressesIndex;   /* dot11GroupAddressesEntry 1 */
    UCHAR       dot11Address[6];            /* dot11GroupAddressesEntry 2 */
    ULONG       dot11GroupAddressesStatus;  /* dot11GroupAddressesEntry 3 */
} DOT11_GROUP_ADDRESSES_ENTRY, *PDOT11_GROUP_ADDRESSES_ENTRY;

/* Entry in dot11ResourceInfo Table: dot11ResourceInfoEntry */
typedef struct _DOT11_RESOURCE_INFO_ENTRY {
    UCHAR       dot11manufacturerOUI[3];    /* dot11ResourceInfoEntry 1 */
    CHAR        dot11manufacturerName[128]; /* dot11ResourceInfoEntry 2 */
    CHAR        dot11manufacturerProductName[128];      /* dot11ResourceInfoEntry 3 */
    CHAR        dot11manufacturerProductVersion[128];   /* dot11ResourceInfoEntry 4 */
} DOT11_RESOURCE_INFO_ENTRY, *PDOT11_RESOURCE_INFO_ENTRY;

/* Entry in PHY dot11PhyOperation Table: dot11PhyOperationEntry */
typedef struct _DOT11_PHY_OPERATION_ENTRY {
    ULONG       dot11PHYType;               /* dot11PhyOperationEntry 1 */
    ULONG       dot11CurrentRegDomain;      /* dot11PhyOperationEntry 2 */
    ULONG       dot11TempType;              /* dot11PhyOperationEntry 3 */
} DOT11_PHY_OPERATION_ENTRY, *PDOT11_PHY_OPERATION_ENTRY;

/* Entry in PHY dot11PhyAntenna Table: dot11PhyAntennaEntry */
typedef struct _DOT11_PHY_ANTENNA_ENTRY {
    ULONG       dot11CurrentTxAntenna;      /* dot11PhyAntennaEntry 1 */
    ULONG       dot11DiversitySupport;      /* dot11PhyAntennaEntry 2 */
    ULONG       dot11CurrentRxAntenna;      /* dot11PhyAntennaEntry 3 */
} DOT11_PHY_ANTENNA_ENTRY, *PDOT11_PHY_ANTENNA_ENTRY;

/* Entry in PHY dot11PhyTxPower Table: dot11PhyTxPowerEntry */
typedef struct _DOT11_PHY_TX_POWER_ENTRY {
    ULONG       dot11NumberSupportedPowerLevels;    /* dot11PhyTxPowerEntry 1 */
    ULONG       dot11TxPowerLevel1;         /* dot11PhyTxPowerEntry 2 */
    ULONG       dot11TxPowerLevel2;         /* dot11PhyTxPowerEntry 3 */
    ULONG       dot11TxPowerLevel3;         /* dot11PhyTxPowerEntry 4 */
    ULONG       dot11TxPowerLevel4;         /* dot11PhyTxPowerEntry 5 */
    ULONG       dot11TxPowerLevel5;         /* dot11PhyTxPowerEntry 6 */
    ULONG       dot11TxPowerLevel6;         /* dot11PhyTxPowerEntry 7 */
    ULONG       dot11TxPowerLevel7;         /* dot11PhyTxPowerEntry 8 */
    ULONG       dot11TxPowerLevel8;         /* dot11PhyTxPowerEntry 9 */
    ULONG       dot11CurrentTxPowerLevel;   /* dot11PhyTxPowerEntry 10 */
} DOT11_PHY_TX_POWER_ENTRY, *PDOT11_PHY_TX_POWER_ENTRY;

/* Entry in PHY dot11PhyDSSSEntry Table: dot11PhyDSSSEntry */
typedef struct _DOT11_PHY_DSSS_ENTRY {
    ULONG       dot11CurrentChannel;        /* dot11PhyDSSSEntry 1 */
    ULONG       dot11CCAModeSupported;      /* dot11PhyDSSSEntry 2 */
    ULONG       dot11CurrentCCAMode;        /* dot11PhyDSSSEntry 3 */
    ULONG       dot11EDThreshold;           /* dot11PhyDSSSEntry 4 */
} DOT11_PHY_DSSS_ENTRY, *PDOT11_PHY_DSSS_ENTRY;
#endif
/* Entry in PHY dot11RegDomainsSupported Table: dot11RegDomainsSupportEntry */
typedef struct _DOT11_REG_DOMAINS_SUPPORT_ENTRY {
    ULONG       dot11RegDomainsSupportIndex;    /* dot11RegDomainsSupportEntry 1 */
    ULONG       dot11RegDomainsSupportValue;    /* dot11RegDomainsSupportEntry 2 */
} DOT11_REG_DOMAINS_SUPPORT_ENTRY, *PDOT11_REG_DOMAINS_SUPPORT_ENTRY;

/* Entry in PHY dot11AntennasList Table: dot11AntennasListEntry */
typedef struct _DOT11_ANTENNAS_LIST_ENTRY {
//    ULONG       dot11AntennaListIndex;      /* dot11AntennasListEntry 1 */
    UCHAR       dot11AntennaListIndex;      /* dot11AntennasListEntry 1 */
//    BOOLEAN     dot11SupportedTxAntenna;    /* dot11AntennasListEntry 2 */
    UCHAR     dot11SupportedTxAntenna;    /* dot11AntennasListEntry 2 */
//    BOOLEAN     dot11SupportedRxAntenna;    /* dot11AntennasListEntry 3 */
    UCHAR     dot11SupportedRxAntenna;    /* dot11AntennasListEntry 3 */
//    BOOLEAN     dot11DiversitySelectionRx;  /* dot11AntennasListEntry 4 */
    UCHAR     dot11DiversitySelectionRx;  /* dot11AntennasListEntry 4 */
} DOT11_ANTENNAS_LIST_ENTRY, *PDOT11_ANTENNAS_LIST_ENTRY;

#if 0
/* Entry in PHY SupportedDataRatesTx Table: dot11SupportedDataRatesTxEntry
   Entry in PHY SupportedDataRatesRx Table: dot11SupportedDataRatesRxEntry */
typedef struct _DOT11_SUPPORTED_DATA_RATES_ENTRY {
    ULONG       dot11SupportedDataRatesIndex;   /* dot11SupportedDataRates(Tx/Rx)Entry 1 */
    ULONG       dot11SupportedDataRatesValue;   /* dot11SupportedDataRates(Tx/Rx)Entry 2 */
} DOT11_SUPPORTED_DATA_RATES_ENTRY, *PDOT11_SUPPORTED_DATA_RATES_ENTRY;

/* Entry in PHY dot11PhyHRDSSSEntry Table: dot11PhyHRDSSSEntry */
typedef struct _DOT11_PHY_HRDSSS_ENTRY {
    BOOLEAN     dot11ShortPreambleOptionImplemented;    /* dot11PhyHRDSSSEntry 1 */
    BOOLEAN     dot11PBCCOptionImplemented; /* dot11PhyHRDSSSEntry 2 */
    BOOLEAN     dot11ChannelAgilityPresent; /* dot11PhyHRDSSSEntry 3 */
    BOOLEAN     dot11ChannelAgilityEnabled; /* dot11PhyHRDSSSEntry 4 */
} DOT11_PHY_HRDSSS_ENTRY, *PDOT11_PHY_HRDSSS_ENTRY;


/* Entry in PHY dot11PhyERPEntry Table: dot11PhyERPEntry */
typedef struct _DOT11_PHY_ERP_ENTRY {
    BOOLEAN     dot11ER_PBCCOptionImplemented;      /* dot11PhyERPEntry 1 */
    BOOLEAN     dot11DSSS_OFDMOptionImplemented;    /* dot11PhyERPEntry 2 */
    BOOLEAN     dot11DSSS_OFDMOptionEnabled;        /* dot11PhyERPEntry 3 */
    BOOLEAN     dot11ShortSlotTimeOptionImplemented;    /* dot11PhyERPEntry 4 */
    BOOLEAN     dot11ShortSlotTimeOptionEnabled;    /* dot11PhyERPEntry 5 */
} DOT11_PHY_ERP_ENTRY, *PDOT11_PHY_ERP_ENTRY;
#endif

#if SUPPORT_802_11A
/* Entry in PHY dot11PhyOFDMEntry Table: dot11PhyOFDMEntry */
typedef struct _DOT11_PHY_OFDM_ENTRY {
    UINT32      dot11CurrentFrequency;          /* dot11PhyOFDMEntry 1 */
    UINT32      dot11TIThreshold;               /* dot11PhyOFDMEntry 2 */
    UINT32      dot11FrequencyBandsSupported;   /* dot11PhyOFDMEntry 3 */
} DOT11_PHY_OFDM_ENTRY, *PDOT11_PHY_OFDM_ENTRY;
#endif

/* ----- Major sections ----- */
#if 0
/* Station ManagemenT (SMT) Attributes */
typedef struct _DOT11_SMT {
    /* dot11StationConfigTable (dot11smt 1) */
    DOT11_STATION_CONFIG_ENTRY staConfig;

    /* dot11AuthenticationAlgorithmsTable (dot11smt 2) */
    UINT        numAuthAlgs;
    DOT11_AUTHENTICATION_ALGORITHMS_ENTRY authAlgs[MAX_NUM_AUTH_ALGORITHM];

    /* dot11WEPDefaultKeysTable (dot11smt 3) */
    DOT11_WEP_DEFAULT_KEYS_ENTRY wepDefaultKey[4];

#if 0
    /* dot11WEPKeyMappingsTable (dot11smt 4) */
    DOT11_WEP_KEY_MAPPINGS_ENTRY wepKeyMapping[WEP_KEY_MAPPING_LEN];
#endif

    /* dot11PrivacyTable (dot11smt 5) */
    DOT11_PRIVACY_ENTRY privacy;
} DOT11_SMT, *PDOT11_SMT;
#endif
#if 0
/* MAC Attributes */
typedef struct _DOT11_MAC {
    /* dot11OperationTable (dot11mac 1) */
    DOT11_OPERATION_ENTRY operation;

    /* dot11CountersTable (dot11mac 2) */
    DOT11_COUNTERS_ENTRY counters;

    /* dot11GroupAddressesTable (dot11mac 3) */
    DOT11_GROUP_ADDRESSES_ENTRY groupAddr[MAX_NUM_GROUP_ADDR];
} DOT11_MAC, *PDOT11_MAC;
#endif
#if 0
/* Resource Attributes */
typedef struct _DOT11_RES {
    /* Resource Type Attributes (dot11res 1) */
    CHAR        resTypeIdName[5];           /* dot11resAttribute 1 */
    DOT11_RESOURCE_INFO_ENTRY resourceInfo;       /* dot11resAttribute 2 */
} DOT11_RES, *PDOT11_RES;
#endif
#if 0
/* PHY Attributes */
typedef struct _DOT11_PHY {
    /* dot11PhyOperationTable (dot11phy 1) */
    DOT11_PHY_OPERATION_ENTRY phyOperation;

    /* dot11PhyAntennaTable (dot11phy 2) */
    DOT11_PHY_ANTENNA_ENTRY phyAntenna;

    /* dot11PhyTxPowerTable (dot11phy 3) */
    DOT11_PHY_TX_POWER_ENTRY phyTxPower;

    /* dot11PhyDSSSTable (dot11phy 5) */
    DOT11_PHY_DSSS_ENTRY phyDsss;

    /* dot11RegDomainsSupportedTable (dot11phy 7) */
    UINT        numRegDomains;
    DOT11_REG_DOMAINS_SUPPORT_ENTRY regDomains[MAX_NUM_SUPPORTED_REG_DOMAIN];

    /* dot11AntennasListTable (dot11phy 8) */
    UINT        numAntennas;
    DOT11_ANTENNAS_LIST_ENTRY antennasList[MAX_NUM_ANTENNA];

    /* dot11SupportedDataRatesTxTable (dot11phy 9) */
    UINT        numSupTxRates;
    DOT11_SUPPORTED_DATA_RATES_ENTRY supTxRates[MAX_NUM_SUPPORTED_DATA_RATES];

    /* dot11SupportedDataRatesRxTable (dot11phy 10) */
    UINT        numSupRxRates;
    DOT11_SUPPORTED_DATA_RATES_ENTRY supRxRates[MAX_NUM_SUPPORTED_DATA_RATES];

    /* dot11PhyHRDSSSTable (dot11phy 12) */
    DOT11_PHY_HRDSSS_ENTRY phyHrdsss;

    /* dot11PhyERPTable (dot11phy 14) */
    DOT11_PHY_ERP_ENTRY phyErp;
} DOT11_PHY, *PDOT11_PHY;
#endif
/* Entry in RSN dot11RSNConfigTalbe Table: dot11RSNConfigEntry */
typedef struct _DOT11_RSN_CONFIG_ENTRY {
//    ULONG           dot11RSNConfigIndex;                 /* dot11RSNConfigEntry 1 */
//    ULONG           dot11RSNConfigVersion;               /* dot11RSNConfigEntry 2 */
//    ULONG           dot11RSNConfigPairwiseKeysSupported; /* dot11RSNConfigEntry 3 */
//    SUITE_SELECTOR  dot11RSNConfigMulticastCipher;       /* dot11RSNConfigEntry 4 */
//    ULONG           dot11RSNConfigGroupRekeyMethod;      /* dot11RSNConfigEntry 5 */
    UCHAR           dot11RSNConfigGroupRekeyMethod;      /* dot11RSNConfigEntry 5 */
//    ULONG           dot11RSNConfigGroupRekeyTime;        /* dot11RSNConfigEntry 6 */
//    ULONG           dot11RSNConfigGroupRekeyPackets;     /* dot11RSNConfigEntry 7 */
//    BOOLEAN         dot11RSNConfigGroupRekeyStrict;      /* dot11RSNConfigEntry 8 */
    UCHAR           dot11RSNConfigPSKValue[RSN_KEY_LEN]; /* dot11RSNConfigEntry 9 */
    UCHAR           dot11RSNConfigPSKPassPhrase[64];     /* dot11RSNConfigEntry 10 */
//    BOOLEAN         dot11RSNConfigTSNEnabled;            /* dot11RSNConfigEntry 11 */
//    ULONG           dot11RSNConfigGroupMasterRekeyTime;  /* dot11RSNConfigEntry 12 */
    ULONG           dot11RSNConfigGroupUpdateTimeout;    /* dot11RSNConfigEntry 13 */
    ULONG           dot11RSNConfigGroupUpdateCount;      /* dot11RSNConfigEntry 14 */
    ULONG           dot11RSNConfigPairwiseUpdateTimeout; /* dot11RSNConfigEntry 15 */
    ULONG           dot11RSNConfigPairwiseUpdateCount;   /* dot11RSNConfigEntry 16 */
//    UCHAR           dot11RSNConfigGroupKeyRSC[6];
//    ULONG           dot11RSNConfigTKIPReplays;
} DOT11_RSN_CONFIG_ENTRY, *PDOT11_RSN_CONFIG_ENTRY;

/* Entry in RSN dot11RSNConfigUnicastCiphersTalbe Table: dot11RSNConfigUnicastCiphersEntry */
typedef struct _DOT11_RSN_CONFIG_UNICAST_CIPHERS_ENTRY {
    ULONG           dot11RSNConfigUnicastCipherIndex;   /* dot11RSNConfigEntry 1 */
    SUITE_SELECTOR  dot11RSNConfigUnicastCipher;        /* dot11RSNConfigEntry 2 */
    BOOLEAN         dot11RSNConfigUnicastCipherEnabled; /* dot11RSNConfigEntry 3 */
} DOT11_RSN_CONFIG_UNICAST_CIPHERS_ENTRY, *PDOT11_RSN_CONFIG_UNICAST_CIPHERS_ENTRY;

/* Entry in RSN dot11RSNConfigAuthenticationSuitesTalbe Table: dot11RSNConfigAuthenticationSuitesEntry */
typedef struct _DOT11_RSN_CONFIG_AUTHENTICATION_SUITES_ENTRY {
    ULONG           dot11RSNConfigAuthenticationSuiteIndex;   /* dot11RSNConfigEntry 1 */
    SUITE_SELECTOR  dot11RSNConfigAuthenticationSuite;        /* dot11RSNConfigEntry 2 */
    BOOLEAN         dot11RSNConfigAuthenticationSuiteEnabled; /* dot11RSNConfigEntry 3 */
} DOT11_RSN_CONFIG_AUTHENTICATION_SUITES_ENTRY, *PDOT11_RSN_CONFIG_AUTHENTICATION_SUITES_ENTRY;

#if 0
/* Entry in RSN dot11RSNStatsTalbe Table: dot11RSNStatsEntry */
typedef struct _DOT11_RSN_STATS_ENTRY {
    ULONG           dot11RSNStatsIndex;                      /* dot11RSNConfigEntry 1 */
    UCHAR           dot11RSNStatsSTAAddress[6];              /* dot11RSNConfigEntry 2 */
    ULONG           dot11RSNStatsVersion;                    /* dot11RSNConfigEntry 3 */
    SUITE_SELECTOR  dot11RSNStatsSelectedUnicastCipher;  /* dot11RSNConfigEntry 4 */
    ULONG           dot11RSNStatsTKIPICVErrors;              /* dot11RSNConfigEntry 5 */
    ULONG           dot11RSNStatsTKIPLocalMICFailures;       /* dot11RSNConfigEntry 6 */
    ULONG           dot11RSNStatsTKIPRemoteMICFailures;      /* dot11RSNConfigEntry 7 */
    ULONG           dot11RSNStatsTKIPCounterMeasuresInvoked; /* dot11RSNConfigEntry 8 */
#if 0
    ULONG           dot11RSNStatsWRAPFormatErrors;           /* dot11RSNConfigEntry 9 */
    ULONG           dot11RSNStatsWRAPReplays;                /* dot11RSNConfigEntry 10 */
    ULONG           dot11RSNStatsWRAPDecryptErrors;          /* dot11RSNConfigEntry 11 */
#endif
    ULONG           dot11RSNStatsCCMPFormatErrors;           /* dot11RSNConfigEntry 12 */
    ULONG           dot11RSNStatsCCMPReplays;                /* dot11RSNConfigEntry 13 */
    ULONG           dot11RSNStatsCCMPDecryptErrors;          /* dot11RSNConfigEntry 14 */
    UCHAR           dot11RSNStatsKeyRSC[6];
    ULONG           dot11RSNStatsTKIPReplays;
} DOT11_RSN_STATS_ENTRY, *PDOT11_RSN_STATS_ENTRY;

/* RSN Attributes */
typedef struct _DOT11_RSN {
    DOT11_RSN_CONFIG_ENTRY                       dot11RSNConfigTable;                                                 /* ieee802dot11i 1 */
    DOT11_RSN_CONFIG_UNICAST_CIPHERS_ENTRY       dot11RSNConfigUnicastCiphersTable[UINCAST_CIPHER_SUITE_COUNT];       /* ieee802dot11i 2 */
    DOT11_RSN_CONFIG_AUTHENTICATION_SUITES_ENTRY dot11RSNConfigAuthenticationSuitesTable[AUTHENTICATION_SUITE_COUNT]; /* ieee802dot11i 3 */
    DOT11_RSN_STATS_ENTRY                        dot11RSNStatsTable[WEP_KEY_MAPPING_LEN];                             /* ieee802dot11i 4 */
} DOT11_RSN, *PDOT11_RSN;
#endif
#if 0
/* IEEE 802.11 MIB */
typedef struct _IEEE_802_DOT_11_MIB {
    DOT11_SMT   smt;                /* ieee802dot11 1 */
    DOT11_MAC   mac;                /* ieee802dot11 2 */
    DOT11_RES   res;                /* ieee802dot11 3 */
    DOT11_PHY   phy;                /* ieee802dot11 4 */
    DOT11_RSN   rsn;                /* ieee802dot11 7 */
} IEEE_802_DOT_11_MIB, *PIEEE_802_DOT_11_MIB;
#endif
typedef struct _IEEE_802_11_MIB {
    /* Station ManagemenT (SMT) Attributes (ieee802dot11 1) */
    /* dot11StationConfigTable (dot11smt 1) */
//    UCHAR       dot11StationID[6];          /* dot11StationConfigEntry 1 */
//    USHORT      dot11MediumOccupancyLimit;  /* dot11StationConfigEntry 2 */
//    BOOLEAN     dot11CFPollable;            /* dot11StationConfigEntry 3 */
//    UCHAR       dot11CFPPeriod;             /* dot11StationConfigEntry 4 */
//    USHORT      dot11CFPMaxDuration;        /* dot11StationConfigEntry 5 */
//  ULONG       dot11AuthenticationResponseTimeOut; /* dot11StationConfigEntry 6 */
//  BOOLEAN     dot11PrivacyOptionImplemented;      /* dot11StationConfigEntry 7 */
//  UCHAR       dot11PowerManagementMode;   /* dot11StationConfigEntry 8 */
    struct {
        UCHAR   ssidLen;
        UCHAR   ssid[33];
    } dot11DesiredSSID;                     /* dot11StationConfigEntry 9 */
//  UCHAR       dot11DesiredBSSType;        /* dot11StationConfigEntry 10 */
    struct {
        UCHAR   rateSetSize;
        UCHAR   rateSet[MAX_NUM_SUPPORTED_DATA_RATES];
    } dot11OperationalRateSet;              /* dot11StationConfigEntry 11 */
    USHORT      dot11BeaconPeriod;          /* dot11StationConfigEntry 12 */
    UCHAR       dot11DTIMPeriod;            /* dot11StationConfigEntry 13 */
//  ULONG       dot11AssociationResponseTimeOut;    /* dot11StationConfigEntry 14 */
//  USHORT      dot11DisassociateReason;    /* dot11StationConfigEntry 15 */
//  UCHAR       dot11DisassociateStation[6];        /* dot11StationConfigEntry 16 */
//  USHORT      dot11DeauthenticateReason;  /* dot11StationConfigEntry 17 */
//  UCHAR       dot11DeauthenticateStation[6];      /* dot11StationConfigEntry 18 */
//  USHORT      dot11AuthenticateFailStatus;        /* dot11StationConfigEntry 19 */
//  UCHAR       dot11AuthenticateFailStation[6];    /* dot11StationConfigEntry 20 */
#if SUPPORT_802_11D
    //BOOLEAN     dot11MultiDomainCapabilityImplemented;  /* dot11StationConfigEntry 21 */
    BOOLEAN     dot11MultiDomainCapabilityEnabled;      /* dot11StationConfigEntry 22 */
    //UINT_8      dot11CountryString[3];      /* dot11StationConfigEntry 23 */
#endif
#if SUPPORT_IPNRSN
//  BOOLEAN     dot11RSNOptionImplemented;          /* dot11StationConfigEntry 24, new added for RSN */
#endif /* SUPPORT_RSN */
    UCHAR       aCWmin;                        /* CWmin for g */

    /* dot11AuthenticationAlgorithmsTable (dot11smt 2) */
//    UINT        numAuthAlgs;
    DOT11_AUTHENTICATION_ALGORITHMS_ENTRY dot11AuthenticationAlgorithmsTable[MAX_NUM_AUTH_ALGORITHM];

    /* dot11WEPDefaultKeysTable (dot11smt 3) */
    DOT11_WEP_DEFAULT_KEYS_ENTRY dot11WEPDefaultKeysTable[4];

    /* dot11WEPKeyMappingsTable (dot11smt 4) */
#if 0
    DOT11_WEP_KEY_MAPPINGS_ENTRY dot11WEPKeyMappingsTable[WEP_KEY_MAPPING_LEN];
#endif

    /* dot11PrivacyTable (dot11smt 5) */
//    BOOLEAN     dot11PrivacyInvoked;        /* dot11PrivacyEntry 1 */
//    ULONG       dot11WEPDefaultKeyID;       /* dot11PrivacyEntry 2 */
//    ULONG       dot11WEPKeyMappingLength;   /* dot11PrivacyEntry 3 */
//    BOOLEAN     dot11ExcludeUnencrypted;    /* dot11PrivacyEntry 4 */
    ULONG       dot11WEPICVErrorCount;      /* dot11PrivacyEntry 5 */
//    ULONG       dot11WEPExcludedCount;      /* dot11PrivacyEntry 6 */
#if SUPPORT_IPNRSN | SUPPORT_WPA2
//    BOOLEAN     dot11RSNEnabled;            /* dot11PrivacyEntry 7 */
    UCHAR     dot11RSNEnabled;            /* dot11PrivacyEntry 7 */
//    BOOLEAN     dot11HaveGTK;               /* dot11PrivacyEntry 8 */
//    BOOLEAN     dot11HavePTK;               /* dot11PrivacyEntry 9 */
//    BOOLEAN     dot11WEPKeyMappingsKeyBroadcast;/* dot11PrivacyEntry 10 */
//    BOOLEAN     dot11Pure1XEnabled;         /* ................... */
    UCHAR     dot11Pure1XEnabled;         /* ................... */
#endif /* SUPPORT_RSN */

    /* MAC Attributes (ieee802dot11 2) */
    /* dot11OperationTable (dot11mac 1) */
    UCHAR       dot11MACAddress[6];         /* dot11OperationEntry 1 */
//    ULONG       dot11RTSThreshold;          /* dot11OperationEntry 2 */
    USHORT     dot11RTSThreshold;          /* dot11OperationEntry 2 */
//    ULONG       dot11ShortRetryLimit;       /* dot11OperationEntry 3 */
    USHORT       dot11ShortRetryLimit;       /* dot11OperationEntry 3 */
//    ULONG       dot11LongRetryLimit;        /* dot11OperationEntry 4 */
    USHORT       dot11LongRetryLimit;        /* dot11OperationEntry 4 */
//    ULONG       dot11FragmentationThreshold;        /* dot11OperationEntry 5 */
    USHORT       dot11FragmentationThreshold;        /* dot11OperationEntry 5 */
//    ULONG       dot11MaxTransmitMSDULifetime;       /* dot11OperationEntry 6 */
//    ULONG       dot11MaxReceiveLifetime;    /* dot11OperationEntry 7 */
//    CHAR        dot11ManufacturerID[128];   /* dot11OperationEntry 8 */
//    CHAR        dot11ProductID[128];        /* dot11OperationEntry 9 */

    /* dot11CountersTable (dot11mac 2) */
    ULONG       dot11TransmittedFragmentCount;          /* dot11CountersEntry 1 */
    ULONG       dot11MulticastTransmittedFrameCount;    /* dot11CountersEntry 2 */
    ULONG       dot11FailedCount;           /* dot11CountersEntry 3 */
    ULONG       dot11RetryCount;            /* dot11CountersEntry 4 */
    ULONG       dot11MultipleRetryCount;    /* dot11CountersEntry 5 */
    ULONG       dot11FrameDuplicateCount;   /* dot11CountersEntry 6 */
    ULONG       dot11RTSSuccessCount;       /* dot11CountersEntry 7 */
    ULONG       dot11RTSFailureCount;       /* dot11CountersEntry 8 */
    ULONG       dot11ACKFailureCount;       /* dot11CountersEntry 9 */
    ULONG       dot11ReceivedFragmentCount; /* dot11CountersEntry 10 */
    ULONG       dot11MulticastReceivedFrameCount;       /* dot11CountersEntry 11 */
    ULONG       dot11FCSErrorCount;         /* dot11CountersEntry 12 */
    ULONG       dot11TransmittedFrameCount; /* dot11CountersEntry 13 */
    ULONG       dot11WEPUndecryptableCount; /* dot11CountersEntry 14 */
#if 0
    /* dot11GroupAddressesTable (dot11mac 3) */
    UINT        numGroupAddresses;
    DOT11_GROUP_ADDRESSES_ENTRY dot11GroupAddressesTable[MAX_NUM_GROUP_ADDR];
#endif
    /* Resource Attributes (ieee802dot11 3) */
    /* Resource Type Attributes (dot11res 1) */
//    CHAR        dot11ResourceTypeIDName[5]; /* dot11resAttribute 1 */
    /* dot11resAttribute 2 */
//    UCHAR       dot11manufacturerOUI[3];    /* dot11ResourceInfoEntry 1 */
//    CHAR        dot11manufacturerName[128]; /* dot11ResourceInfoEntry 2 */
//    CHAR        dot11manufacturerProductName[128];      /* dot11ResourceInfoEntry 3 */
//    CHAR        dot11manufacturerProductVersion[128];   /* dot11ResourceInfoEntry 4 */

    /* PHY Attributes (ieee802dot11 4) */
    /* dot11PhyOperationTable (dot11phy 1) */
//    ULONG       dot11PHYType;               /* dot11PhyOperationEntry 1 */
//    ULONG       dot11CurrentRegDomain;      /* dot11PhyOperationEntry 2 */
    UCHAR       dot11CurrentRegDomain;      /* dot11PhyOperationEntry 2 */
//    ULONG       dot11TempType;              /* dot11PhyOperationEntry 3 */

    /* dot11PhyAntennaTable (dot11phy 2) */
//    ULONG       dot11CurrentTxAntenna;      /* dot11PhyAntennaEntry 1 */
    UCHAR       dot11CurrentTxAntenna;      /* dot11PhyAntennaEntry 1 */
//    ULONG       dot11DiversitySupport;      /* dot11PhyAntennaEntry 2 */
    UCHAR       dot11DiversitySupport;      /* dot11PhyAntennaEntry 2 */
    ULONG       dot11CurrentRxAntenna;      /* dot11PhyAntennaEntry 3 */

    /* dot11PhyTxPowerTable (dot11phy 3) */
//    ULONG       dot11NumberSupportedPowerLevels;    /* dot11PhyTxPowerEntry 1 */
//    ULONG       dot11TxPowerLevel[8];       /* dot11PhyTxPowerEntry 2 ... 9 */
//    ULONG       dot11CurrentTxPowerLevel;   /* dot11PhyTxPowerEntry 10 */

    /* dot11PhyDSSSTable (dot11phy 5) */
//    ULONG       dot11CurrentChannel;        /* dot11PhyDSSSEntry 1 */
    USHORT       dot11CurrentChannel;        /* dot11PhyDSSSEntry 1 */
//    ULONG       dot11CCAModeSupported;      /* dot11PhyDSSSEntry 2 */
//    ULONG       dot11CurrentCCAMode;        /* dot11PhyDSSSEntry 3 */
//    ULONG       dot11EDThreshold;           /* dot11PhyDSSSEntry 4 */
#if 0
    /* dot11RegDomainsSupportedTable (dot11phy 7) */
    UINT        numRegDomains;
    DOT11_REG_DOMAINS_SUPPORT_ENTRY dot11RegDomainsSupportedTable[MAX_NUM_SUPPORTED_REG_DOMAIN];
#endif
    /* dot11AntennasListTable (dot11phy 8) */
//    UINT        numAntennas;
    UCHAR        numAntennas;
    DOT11_ANTENNAS_LIST_ENTRY dot11AntennasListTable[MAX_NUM_ANTENNA];
#if 0
    /* dot11SupportedDataRatesTxTable (dot11phy 9) */
    UINT        numSupportedTxRates;
    DOT11_SUPPORTED_DATA_RATES_ENTRY dot11SupportedDataRatesTxTable[MAX_NUM_SUPPORTED_DATA_RATES];

    /* dot11SupportedDataRatesRxTable (dot11phy 10) */
    UINT        numSupportedRxRates;
    DOT11_SUPPORTED_DATA_RATES_ENTRY dot11SupportedDataRatesRxTable[MAX_NUM_SUPPORTED_DATA_RATES];
#endif

#if SUPPORT_802_11A
    /* dot11PhyOFDMTable (dot11phy 11) */
    UINT32      dot11CurrentFrequency;          /* dot11PhyOFDMEntry 1 */
    UINT32      dot11TIThreshold;               /* dot11PhyOFDMEntry 2 */
    UINT32      dot11FrequencyBandsSupported;   /* dot11PhyOFDMEntry 3 */
#endif

    /* dot11PhyHRDSSSTable (dot11phy 12) */
//    BOOLEAN     dot11ShortPreambleOptionImplemented;    /* dot11PhyHRDSSSEntry 1 */
//    BOOLEAN     dot11PBCCOptionImplemented; /* dot11PhyHRDSSSEntry 2 */
//    BOOLEAN     dot11ChannelAgilityPresent; /* dot11PhyHRDSSSEntry 3 */
//    BOOLEAN     dot11ChannelAgilityEnabled; /* dot11PhyHRDSSSEntry 4 */

    /* dot11PhyERPTable (dot11phy 14) */
//    BOOLEAN     dot11ER_PBCCOptionImplemented;      /* dot11PhyERPEntry 1 */
//    BOOLEAN     dot11DSSS_OFDMOptionImplemented;    /* dot11PhyERPEntry 2 */
//    BOOLEAN     dot11DSSS_OFDMOptionEnabled;        /* dot11PhyERPEntry 3 */
//    BOOLEAN     dot11ShortSlotTimeOptionImplemented;    /* dot11PhyERPEntry 4 */
//    BOOLEAN     dot11ShortSlotTimeOptionEnabled;    /* dot11PhyERPEntry 5 */

#if SUPPORT_IPNRSN
    /* RSN Attributes (ieee802dot11 7) */
    /* dot11RSNConfigTable (ieee802dot11i 1) */
    DOT11_RSN_CONFIG_ENTRY  dot11RSNConfigTable;

    /* dot11RSNConfigUnicastCiphersTable (ieee802dot11i 2) */
    DOT11_RSN_CONFIG_UNICAST_CIPHERS_ENTRY  dot11RSNConfigUnicastCiphersTable[UINCAST_CIPHER_SUITE_COUNT];

    /* dot11RSNConfigAuthenticationSuitesTable (ieee802dot11i 3) */
    DOT11_RSN_CONFIG_AUTHENTICATION_SUITES_ENTRY  dot11RSNConfigAuthenticationSuitesTable[AUTHENTICATION_SUITE_COUNT];
#if 0
    /* dot11RSNConfigAuthenticationSuitesTable (ieee802dot11i 4) */
    DOT11_RSN_STATS_ENTRY  dot11RSNStatsTable[WEP_KEY_MAPPING_LEN];
#endif

#endif /* SUPPORT_RSN */

    /*802.11e attributes*/
    /*SMT EDCF config table*/
    UCHAR       dot11EDCFCWmin[4];
    USHORT      dot11EDCFCWmax[4];
    UCHAR       dot11EDCFAIFSN[4];
    USHORT      dot11EDCFTXOPLimit[4];
} IEEE_802_11_MIB, *PIEEE_802_11_MIB;

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*                    D A T A   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/


#endif /* _80211MIB_H */

