/*
** $Id: rf_maxim.c 1.12 2004/09/24 19:45:47 patlu Exp $
*/

/*************************************************************************
* Copyright (c) 2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define PAU_TNTDR_MAXIM_LONG_SLOT               0x02060094
#define PAU_TNTDR_MAXIM_SHORT_SLOT              0x012a0094

#define PAU_STDR_MAXIM_LONG_SLOT                0x01900190
#define PAU_STDR_MAXIM_SHORT_SLOT               0x00b400b4

#define RF_INIT_WAIT_DELAY_MAXIM                100

#define RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_24   -70
#define RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_5    -72

#define TX_POWER_GAIN_MAXIM_CCK                 0x2C
#define TX_POWER_GAIN_MAXIM_OFDM_24             0x32
#define TX_POWER_GAIN_MAXIM_OFDM_5              0x33

#define TX_POWER_GAIN_STEP_MAXIM_NUM            1
#define TX_POWER_GAIN_STEP_MAXIM_DENOM          2

#define RSSI_COEFF_A_2_MAXIM2825_2827_24                 0
#define RSSI_COEFF_A_1_MAXIM2825_2827_24                 -20473
#define RSSI_COEFF_A_0_MAXIM2825_2827_24                 -30368
#define RSSI_COEFF_C_LNA_0_MAXIM2825_2827_24             0
#define RSSI_COEFF_C_LNA_1_MAXIM2825_2827_24             -300006

#define RSSI_COEFF_A_2_MAXIM2825_2827_5                  -56
#define RSSI_COEFF_A_1_MAXIM2825_2827_5                  -18556
#define RSSI_COEFF_A_0_MAXIM2825_2827_5                  -327471
#define RSSI_COEFF_C_LNA_0_MAXIM2825_2827_5              260000
#define RSSI_COEFF_C_LNA_1_MAXIM2825_2827_5              0


#define RSSI_COEFF_A_2_MAXIM2829_24                      0
#define RSSI_COEFF_A_1_MAXIM2829_24                      -20000
#define RSSI_COEFF_A_0_MAXIM2829_24                      -366000
#define RSSI_COEFF_C_LNA_0_MAXIM2829_24                  300000
#define RSSI_COEFF_C_LNA_1_MAXIM2829_24                  0

#define RSSI_COEFF_A_2_MAXIM2829_5                       -101
#define RSSI_COEFF_A_1_MAXIM2829_5                       -17665
#define RSSI_COEFF_A_0_MAXIM2829_5                       -363128
#define RSSI_COEFF_C_LNA_0_MAXIM2829_5                   300000
#define RSSI_COEFF_C_LNA_1_MAXIM2829_5                   0

#define NIC_PM_WAKE_UP_TIME_MAXIM               500


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
const NIC_MCR_CONFIG_ENTRY pauInitTableForMaxim_24[] = {
#if MAXIM_PAEN_ACTIVE_HIGH
    {MCR_PCICR,     0x00000180},
#else
    {MCR_PCICR,     0x00000100},
#endif
    {MCR_PSCR,      0x39221222},
    {MCR_PPORCR0,   0x00000014},
    {MCR_PPORCR1,   0x003e003e},
    {MCR_PPDRCR0,   0x0024000a},
    {MCR_PPDRCR1,   0x00140014},
    {MCR_PPDRCR2,   0x00000050},
    {MCR_MPDR,      0x001e761e},
    {MCR_TNTDR,     PAU_TNTDR_MAXIM_LONG_SLOT},
    {MCR_STDR,      PAU_STDR_MAXIM_LONG_SLOT},
    {MCR_BGCR0,     (TX_POWER_GAIN_MAXIM_CCK << 8)},
    {MCR_RFTPCR,    (TX_POWER_GAIN_MAXIM_CCK | (TX_POWER_GAIN_MAXIM_OFDM_24 << 8))}
};

#if SUPPORT_802_11A
const NIC_MCR_CONFIG_ENTRY pauInitTableForMaxim_5[] = {
#if MAXIM_PAEN_ACTIVE_HIGH
    {MCR_PCICR,     0x000001A0},
#else
    {MCR_PCICR,     0x00000100},
#endif
    {MCR_PSCR,      0x39221222},
    {MCR_PPORCR0,   0x00000014},
    {MCR_PPORCR1,   0x003e003e},
    {MCR_PPDRCR0,   0x0024000a},
    {MCR_PPDRCR1,   0x00140014},
    {MCR_PPDRCR2,   0x00000050},
    {MCR_MPDR,      0x001e761e},
    {MCR_TNTDR,     PAU_TNTDR_MAXIM_SHORT_SLOT},
    {MCR_STDR,      PAU_STDR_MAXIM_SHORT_SLOT},
    {MCR_BGCR0,     (TX_POWER_GAIN_MAXIM_OFDM_5 << 8)},
    {MCR_RFTPCR,    (TX_POWER_GAIN_MAXIM_CCK | (TX_POWER_GAIN_MAXIM_OFDM_5 << 8))}
};
#endif

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForMaxim[] = {
    {"CR1 ",  1,  0x00},
    {"CR68", 68,  0x50},
    {"CR69", 69,  0x28},
    {"CR81", 81,  0x00},
    {"CR82", 82,  0x00},
    {"CR83", 83,  0xff},
    {"CR5 ",  5,  0x00},

#if BB_FPGA_VERSION_TABLE
    {"CR77", 77,  0xe4},
#else
    {"CR77", 77,  0x90},
#endif

    {"CR45", 45,  0x4b},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x78},
    {"CR46", 46,  0x16},
    {"CR45", 45,  0x79},
    {"CR46", 46,  0x14},

    {"CR45", 45,  0x4c},
    {"CR46", 46,  0xd0},
    {"CR45", 45,  0x7a},
    {"CR46", 46,  0xa2},

    {"CR45", 45,  0x5d},
    {"CR46", 46,  0x83},
    {"CR45", 45,  0x5e},
    {"CR46", 46,  0x57},
    {"CR45", 45,  0x5f},
    {"CR46", 46,  0x39},
    {"CR45", 45,  0x60},
    {"CR46", 46,  0x26},
    {"CR45", 45,  0x61},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x62},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x63},
    {"CR46", 46,  0x0a},

#if BB_FPGA_VERSION_TABLE
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x49},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0x66},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0xe1},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0xa7},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x2f},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xbf},
#else
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x24},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0xb3},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0x50},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x97},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xe6},
#endif

    {"CR45", 45,  0x6a},
    {"CR46", 46,  0x52},
    {"CR45", 45,  0x6b},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x6c},
    {"CR46", 46,  0x33},
    {"CR45", 45,  0x6d},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x6e},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x6f},
    {"CR46", 46,  0x0c},
    {"CR45", 45,  0x70},
    {"CR46", 46,  0x08},

    {"CR45", 45,  0x71},
    {"CR46", 46,  0x00},
    {"CR45", 45,  0x72},
    {"CR46", 46,  0x02},
    {"CR45", 45,  0x73},
    {"CR46", 46,  0xce},
    {"CR45", 45,  0x74},
    {"CR46", 46,  0x45},
    {"CR45", 45,  0x75},
    {"CR46", 46,  0x67},
    {"CR45", 45,  0x76},
    {"CR46", 46,  0x23}
};

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForMaxim_24[] = {
    //{"CR3",   3,  0x31},

    {"CR45", 45,  0x54},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x55},
    {"CR46", 46,  0x1a},
    {"CR45", 45,  0x52},
    {"CR46", 46,  0x1e},

    {"CR45", 45,  0x56},
#if BB_FPGA_VERSION_TABLE
    {"CR46", 46,  0xa1},
#else
    {"CR46", 46,  0x89},
#endif
    {"CR45", 45,  0x57},
    {"CR46", 46,  0x50},

    {"CR45", 45,  0x00},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x01},
    {"CR46", 46,  0xa4},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x23},
    {"CR45", 45,  0x03},
    {"CR46", 46,  0x52},
    {"CR45", 45,  0x04},
    {"CR46", 46,  0x22},

    {"CR49", 49,  0x04},
    {"CR50", 50,  0x84}
};

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForMaxim_5[] = {
    //{"CR3",   3,  0x3b},

    {"CR45", 45,  0x54},
    {"CR46", 46,  0x1a},
    {"CR45", 45,  0x55},
    {"CR46", 46,  0x1b},
    {"CR45", 45,  0x52},
    {"CR46", 46,  0x1e},

    {"CR45", 45,  0x56},
#if BB_FPGA_VERSION_TABLE
    {"CR46", 46,  0xa1},
#else
    {"CR46", 46,  0x91},
#endif
    {"CR45", 45,  0x57},
    {"CR46", 46,  0x10},

    {"CR45", 45,  0x00},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x01},
    {"CR46", 46,  0xa2},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x21},
    {"CR45", 45,  0x03},
    {"CR46", 46,  0x22},
    {"CR45", 45,  0x04},
    {"CR46", 46,  0x32},

    {"CR49", 49,  0x05},
    {"CR50", 50,  0x84}
};


const UINT_32 phyRFInitTableForMaxim2825_2827[] = {
    0x80011400,
    0x80000ca1,
    0x800100f2,
    0x80030A23,
    0x8001ddd4,
    0x80004006,
    0x800002a7,
    0x80008218,
    0x80002009,
    0x80003c0a,
    0x800007fb,
    0x8000000c
};

const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForMaxim2825_2827_24[] = {
    { 1,    3,  { 0x80018605, 0x80000A03, 0x80033334} },
    { 2,    3,  { 0x80018605, 0x80020A13, 0x80008884} },
    { 3,    3,  { 0x80018605, 0x80030A13, 0x8001ddd4} },
    { 4,    3,  { 0x80018605, 0x80000A13, 0x80033334} },
    { 5,    3,  { 0x80018605, 0x80020A23, 0x80008884} },
    { 6,    3,  { 0x80018605, 0x80030A23, 0x8001ddd4} },
    { 7,    3,  { 0x80018605, 0x80000A23, 0x80033334} },
    { 8,    3,  { 0x80018605, 0x80020A33, 0x80008884} },
    { 9,    3,  { 0x80018605, 0x80030A33, 0x8001ddd4} },
    { 10,   3,  { 0x80018605, 0x80000A33, 0x80033334} },
    { 11,   3,  { 0x80018605, 0x80020A43, 0x80008884} },
    { 12,   3,  { 0x80018605, 0x80030A43, 0x8001ddd4} },
    { 13,   3,  { 0x80018605, 0x80000A43, 0x80033334} },
    { 14,   3,  { 0x80018605, 0x80010A53, 0x80026664} }
};

#if SUPPORT_802_11A
const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForMaxim2825_2827_5[] = {
    { 34,   3,  { 0x80018615, 0x80010CE3, 0x80033334} },
    { 36,   3,  { 0x80018615, 0x80030CF3, 0x8000CCC4} },
    { 38,   3,  { 0x80018615, 0x80020CF3, 0x80026664} },
    { 40,   3,  { 0x80018615, 0x80000D03, 0x80000004} },
    { 42,   3,  { 0x80018615, 0x80020D03, 0x80019994} },
    { 44,   3,  { 0x80018615, 0x80000D03, 0x80033334} },
    { 46,   3,  { 0x80018615, 0x80030D13, 0x8000CCC4} },
    { 48,   3,  { 0x80018615, 0x80010D13, 0x80026664} },

    { 52,   3,  { 0x80018615, 0x80020D23, 0x80019994} },
    { 56,   3,  { 0x80018615, 0x80030D33, 0x8000CCC4} },
    { 60,   3,  { 0x80018615, 0x80000D43, 0x80000004} },
    { 64,   3,  { 0x80018615, 0x80000D43, 0x80033334} }
};
#endif

const UINT_32 phyRFInitTableForMaxim2829[] = {
    0x80011400,
    0x800012b1,
    0x80010072,
    0x80018225,
    0x8001c006,
    0x800002a7,
    0x80000218,
    0x80003079,
    0x80003c0a,
    0x800003fb,
    0x8000000c
};

const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForMaxim2829_24[] = {
    { 1,    3,  { 0x80018225, 0x80000A03, 0x80033334} },
    { 2,    3,  { 0x80018225, 0x80020A13, 0x80008884} },
    { 3,    3,  { 0x80018225, 0x80030A13, 0x8001ddd4} },
    { 4,    3,  { 0x80018225, 0x80000A13, 0x80033334} },
    { 5,    3,  { 0x80018225, 0x80020A23, 0x80008884} },
    { 6,    3,  { 0x80018225, 0x80030A23, 0x8001ddd4} },
    { 7,    3,  { 0x80018225, 0x80000A23, 0x80033334} },
    { 8,    3,  { 0x80018225, 0x80020A33, 0x80008884} },
    { 9,    3,  { 0x80018225, 0x80030A33, 0x8001ddd4} },
    { 10,   3,  { 0x80018225, 0x80000A33, 0x80033334} },
    { 11,   3,  { 0x80018225, 0x80020A43, 0x80008884} },
    { 12,   3,  { 0x80018225, 0x80030A43, 0x8001ddd4} },
    { 13,   3,  { 0x80018225, 0x80000A43, 0x80033334} },
    { 14,   3,  { 0x80018225, 0x80010A53, 0x80026664} }
};

#if SUPPORT_802_11A
const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForMaxim2829_5[] = {
    { 8,    3,  { 0x80018235, 0x80010C93, 0x80026664} },
    { 12,   3,  { 0x80018235, 0x80020CA3, 0x80019994} },
    { 16,   3,  { 0x80018235, 0x80030cb3, 0x8000ccc4} },

    { 34,   3,  { 0x80018235, 0x80000CE3, 0x80033334} },
    { 36,   3,  { 0x80018235, 0x80030CF3, 0x8000CCC4} },
    { 38,   3,  { 0x80018235, 0x80010CF3, 0x80026664} },
    { 40,   3,  { 0x80018235, 0x80000D03, 0x80000004} },
    { 42,   3,  { 0x80018235, 0x80020D03, 0x80019994} },
    { 44,   3,  { 0x80018235, 0x80000D03, 0x80033334} },
    { 46,   3,  { 0x80018235, 0x80030D13, 0x8000CCC4} },
    { 48,   3,  { 0x80018235, 0x80010D13, 0x80026664} },

    { 52,   3,  { 0x80018235, 0x80020D23, 0x80019994} },
    { 56,   3,  { 0x80018235, 0x80030D33, 0x8000CCC4} },
    { 60,   3,  { 0x80018235, 0x80000D43, 0x80000004} },
    { 64,   3,  { 0x80018235, 0x80000D43, 0x80033334} },

    { 100,  3,  { 0x80018635, 0x80000DC3, 0x80000004} },
    { 104,  3,  { 0x80018635, 0x80000DC3, 0x80033334} },
    { 108,  3,  { 0x80018635, 0x80010DD3, 0x80026664} },
    { 112,  3,  { 0x80018635, 0x80020DE3, 0x80019994} },
    { 116,  3,  { 0x80018635, 0x80030DF3, 0x8000CCC4} },
    { 120,  3,  { 0x80018635, 0x80000E03, 0x80000004} },
    { 124,  3,  { 0x80018635, 0x80000E03, 0x80033334} },
    { 128,  3,  { 0x80018635, 0x80010E13, 0x80026664} },
    { 132,  3,  { 0x80018635, 0x80020E23, 0x80019994} },
    { 136,  3,  { 0x80018635, 0x80030E33, 0x8000CCC4} },
    { 140,  3,  { 0x80018635, 0x80000E43, 0x80000004} },

    { 149,  3,  { 0x80018635, 0x80000E53, 0x80033334} },
    { 153,  3,  { 0x80018635, 0x80010E63, 0x80026664} },
    { 157,  3,  { 0x80018635, 0x80020E73, 0x80019994} },
    { 161,  3,  { 0x80018635, 0x80030E83, 0x8000CCC4} },

    { 240,  3,  { 0x80018235, 0x80000C43, 0x80033334} },
    { 244,  3,  { 0x80018235, 0x80010C53, 0x80026664} },
    { 248,  3,  { 0x80018235, 0x80020C63, 0x80019994} },
    { 252,  3,  { 0x80018235, 0x80030C73, 0x8000CCC4} }
};
#endif

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
const ED_FLOATED_MARGIN_STRUC edFloatedMarginsForMaxim[ED_FLOAT_ED_LEVELS] = {
        {0x10, 0x16, 0x14},
        {0x18, 0x1a, 0x1a},
        {0x1f, 0x1f, 0x1f}
};
#endif


static
VOID
phyRFInitForMaxim2825_2827(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFInitForMaxim2829(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterActiveForMaxim(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterSleepForMaxim(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFSwitchChannelForMaxim2825_2827(IN PMP_ADAPTER adapter_p,
                                    IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p);

static
VOID
phyRFSwitchChannelForMaxim2829(IN PMP_ADAPTER adapter_p,
                               IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p);

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
static
BOOLEAN
edGetFloatedMarginsForMaxim(IN PMP_ADAPTER adapter_p,
                            IN UINT floatLevel,
                            OUT PUINT_8 marginAGCED_p,
                            OUT PUINT_8 marginCCK_p,
                            OUT PUINT_8 marginOFDM_p);
#endif


NIC_RF_SPECIFIC_CONFIG rfConfigMaxim2825_2827 = {
    NIC_RF_MAXIM_2825_2827,
    "Maxim MAX2825/MAX2827",

    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForMaxim_24,
    sizeof(pauInitTableForMaxim_24) / sizeof(NIC_MCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForMaxim_5,
    sizeof(pauInitTableForMaxim_5) / sizeof(NIC_MCR_CONFIG_ENTRY),
#endif

    PAU_TNTDR_MAXIM_LONG_SLOT,
    PAU_STDR_MAXIM_LONG_SLOT,

    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim,
    sizeof(phyBBInitTableForMaxim) / sizeof(NIC_BBCR_CONFIG_ENTRY),
    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim_24,
    sizeof(phyBBInitTableForMaxim_24) / sizeof(NIC_BBCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim_5,
    sizeof(phyBBInitTableForMaxim_5) / sizeof(NIC_BBCR_CONFIG_ENTRY),
#endif

    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif
    RF_INIT_WAIT_DELAY_MAXIM,

    phyRFInitForMaxim2825_2827,
    phyRFEnterActiveForMaxim,
    phyRFEnterSleepForMaxim,
    phyRFSwitchChannelForMaxim2825_2827,
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    edGetFloatedMarginsForMaxim,
#endif

    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForMaxim2825_2827_24,
    sizeof(phyRFChnlTableForMaxim2825_2827_24) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForMaxim2825_2827_5,
    sizeof(phyRFChnlTableForMaxim2825_2827_5) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#endif

    RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_24,
#if SUPPORT_802_11A
    RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_5,
#endif

    TX_POWER_GAIN_MAXIM_CCK,
    TX_POWER_GAIN_MAXIM_OFDM_24,
#if SUPPORT_802_11A
    TX_POWER_GAIN_MAXIM_OFDM_5,
#endif

    TX_POWER_GAIN_STEP_MAXIM_NUM,
    TX_POWER_GAIN_STEP_MAXIM_DENOM,

    RSSI_COEFF_A_2_MAXIM2825_2827_24,
    RSSI_COEFF_A_1_MAXIM2825_2827_24,
    RSSI_COEFF_A_0_MAXIM2825_2827_24,
    RSSI_COEFF_C_LNA_0_MAXIM2825_2827_24,
    RSSI_COEFF_C_LNA_1_MAXIM2825_2827_24,
#if SUPPORT_802_11A
    RSSI_COEFF_A_2_MAXIM2825_2827_5,
    RSSI_COEFF_A_1_MAXIM2825_2827_5,
    RSSI_COEFF_A_0_MAXIM2825_2827_5,
    RSSI_COEFF_C_LNA_0_MAXIM2825_2827_5,
    RSSI_COEFF_C_LNA_1_MAXIM2825_2827_5,
#endif

    NIC_PM_WAKE_UP_TIME_MAXIM,

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    FALSE
#endif
};


NIC_RF_SPECIFIC_CONFIG rfConfigMaxim2829 = {
    NIC_RF_MAXIM_2829,
    "Maxim MAX2829",

    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForMaxim_24,
    sizeof(pauInitTableForMaxim_24) / sizeof(NIC_MCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForMaxim_5,
    sizeof(pauInitTableForMaxim_5) / sizeof(NIC_MCR_CONFIG_ENTRY),
#endif

    PAU_TNTDR_MAXIM_LONG_SLOT,
    PAU_STDR_MAXIM_LONG_SLOT,

    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim,
    sizeof(phyBBInitTableForMaxim) / sizeof(NIC_BBCR_CONFIG_ENTRY),
    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim_24,
    sizeof(phyBBInitTableForMaxim_24) / sizeof(NIC_BBCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForMaxim_5,
    sizeof(phyBBInitTableForMaxim_5) / sizeof(NIC_BBCR_CONFIG_ENTRY),
#endif

    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif
    RF_INIT_WAIT_DELAY_MAXIM,

    phyRFInitForMaxim2829,
    phyRFEnterActiveForMaxim,
    phyRFEnterSleepForMaxim,
    phyRFSwitchChannelForMaxim2829,
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    edGetFloatedMarginsForMaxim,
#endif

    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForMaxim2829_24,
    sizeof(phyRFChnlTableForMaxim2829_24) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#if SUPPORT_802_11A
    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForMaxim2829_5,
    sizeof(phyRFChnlTableForMaxim2829_5) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#endif

    RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_24,
#if SUPPORT_802_11A
    RSSI_AT_NOISE_FLOOR_BASELINE_MAXIM_5,
#endif

    TX_POWER_GAIN_MAXIM_CCK,
    TX_POWER_GAIN_MAXIM_OFDM_24,
#if SUPPORT_802_11A
    TX_POWER_GAIN_MAXIM_OFDM_5,
#endif

    TX_POWER_GAIN_STEP_MAXIM_NUM,
    TX_POWER_GAIN_STEP_MAXIM_DENOM,

    RSSI_COEFF_A_2_MAXIM2829_24,
    RSSI_COEFF_A_1_MAXIM2829_24,
    RSSI_COEFF_A_0_MAXIM2829_24,
    RSSI_COEFF_C_LNA_0_MAXIM2829_24,
    RSSI_COEFF_C_LNA_1_MAXIM2829_24,
#if SUPPORT_802_11A
    RSSI_COEFF_A_2_MAXIM2829_5,
    RSSI_COEFF_A_1_MAXIM2829_5,
    RSSI_COEFF_A_0_MAXIM2829_5,
    RSSI_COEFF_C_LNA_0_MAXIM2829_5,
    RSSI_COEFF_C_LNA_1_MAXIM2829_5,
#endif

    NIC_PM_WAKE_UP_TIME_MAXIM,

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    FALSE
#endif
};


/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
DEBUGFILE("rf_maxim.c");


/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*_________________________________________________________________________
**  phyRFInitForMaxim2825_2827
**
**  descriptions: This routine is called to initialize Maxim
**                MAX2825/MAX2827 RF chipsets.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFInitForMaxim2825_2827(IN PMP_ADAPTER adapter_p)
{
    BOOLEAN status;
    UINT_32 temp32;

    DEBUGFUNC("phyRFInitForMaxim2825_2827");

    INITLOG(("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 &= ~PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);
    mpStallExecutionMsec(1);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x80018605,
        PSPR_SYNTH_PROG_START, 2, 5, status);
    NdisStallExecution(50);
    NdisStallExecution(50);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x800100f2,
        PSPR_SYNTH_PROG_START, 2, 5, status);
    NdisStallExecution(50);
    NdisStallExecution(50);

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);
    mpStallExecutionMsec(1);

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFInitTableForMaxim2825_2827,
        sizeof(phyRFInitTableForMaxim2825_2827) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_MAXIM);

}   /* phyRFInitForMaxim2825_2827 */

/*_________________________________________________________________________
**  phyRFInitForMaxim2829
**
**  descriptions: This routine is called to initialize Maxim MAX2829 RF
**                chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFInitForMaxim2829(IN PMP_ADAPTER adapter_p)
{
    UINT_32 temp32;

    DEBUGFUNC("phyRFInitForMaxim2829");

    INITLOG(("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 &= ~PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);
    mpStallExecutionMsec(1);

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);
    mpStallExecutionMsec(1);

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFInitTableForMaxim2829,
        sizeof(phyRFInitTableForMaxim2829) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_MAXIM);

}   /* phyRFInitForMaxim2829 */

/*_________________________________________________________________________
**  phyRFEnterActiveForMaxim
**
**  descriptions: This routine is called to let Maxim RF chipset enter RF
**                active state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterActiveForMaxim(IN PMP_ADAPTER adapter_p)
{
    UINT_32 temp32;

    DEBUGFUNC("phyRFEnterActiveForMaxim");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);
}   /* phyRFEnterActiveForMaxim */

/*_________________________________________________________________________
**  phyRFEnterSleepForMaxim
**
**  descriptions: This routine is called to let Maxim RF chipset enter RF
**                sleep state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterSleepForMaxim(IN PMP_ADAPTER adapter_p)
{
    UINT_32 tmp32;

    DEBUGFUNC("phyRFEnterSleepForMaxim");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &tmp32);
    tmp32 &= ~PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, tmp32);
}   /* phyRFEnterSleepForMaxim */

/*_________________________________________________________________________
**  phyRFSwitchChannelForMaxim2825_2827
**
**  descriptions: This routine is called to switch channel for Maxim
**                MAX2825/MAX2827 RF chipsets.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFSwitchChannelForMaxim2825_2827(IN PMP_ADAPTER adapter_p,
                                    IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p)
{
    UINT i;
    BOOLEAN status;

    DEBUGFUNC("phyRFSwitchChannelForMaxim2825_2827");

    DBGLOG(HW, TRACE, ("\n"));

    for (i = 0; i < entry_p->numSynthProgWords; i++) {
        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, entry_p->synthProgWords[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);

        ASSERT(status);
    }
}   /* phyRFSwitchChannelForMaxim2825_2827 */

/*_________________________________________________________________________
**  phyRFSwitchChannelForMaxim2829
**
**  descriptions: This routine is called to switch channel for Maxim
**                MAX2829 RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFSwitchChannelForMaxim2829(IN PMP_ADAPTER adapter_p,
                               IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p)
{
    UINT i;
    BOOLEAN status;
    UINT_32 temp32;

    DEBUGFUNC("phyRFSwitchChannelForMaxim2829");

    DBGLOG(HW, TRACE, ("\n"));

    for (i = 0; i < entry_p->numSynthProgWords; i++) {
        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, entry_p->synthProgWords[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);

        ASSERT(status);
    }

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 ^= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);

    for (i = 0; i < 6; i++) {
        NdisStallExecution(50);
    }

    temp32 ^= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR,
        entry_p->synthProgWords[0] | BIT(11), PSPR_SYNTH_PROG_START, 2, 5,
        status);

    ASSERT(status);
}   /* phyRFSwitchChannelForMaxim2829 */

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
/*_________________________________________________________________________
**  edGetFloatedMarginsForMaxim
**
**  descriptions: This routine is called to get a set of floated ED margins
**                for Maxim RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      floatLevel - The current ED float level
**  results:
**      marginAGCED_p - Pointer to the AGC ED margin
**      marginCCK_p - Pointer to the CCK margin
**      marginOFDM_p - Pointer to the OFDM margin
**  return:
**      TRUE
**  note:
**__________________________________________________________________________*/
static
BOOLEAN
edGetFloatedMarginsForMaxim(IN PMP_ADAPTER adapter_p,
                            IN UINT floatLevel,
                            OUT PUINT_8 marginAGCED_p,
                            OUT PUINT_8 marginCCK_p,
                            OUT PUINT_8 marginOFDM_p)
{
    DEBUGFUNC("edGetFloatedMarginsForMaxim");

    DBGLOG(HW, INFO, ("\n"));

    *marginAGCED_p = edFloatedMarginsForMaxim[floatLevel].AGCEDMargin;
    *marginCCK_p = edFloatedMarginsForMaxim[floatLevel].CCKMargin;
    *marginOFDM_p = edFloatedMarginsForMaxim[floatLevel].OFDMMargin;

    return TRUE;
}   /* edGetFloatedMarginsForMaxim */
#endif

